#include <iostream>
#include <string>
#include "share/ActionProDef.h"
#include "share/PWalkDef.h"
#include "share/Common.h"
#include "actuatorControl/ActionPro.h"

using namespace std;

ActionPro actionPro;

void initialize(){
    actionPro.initMem();
}

#if TEMP_COMMENTED_OUT
void testPWalk(){
    PWalk pAgent;

    double theta1, theta2, theta3;
    double x,y,z;
    while ( cin >> x >> y >> z){
        pAgent.backJointAngles(x,y,z, theta1,theta2,theta3);
        cout << " T1 = " << RAD2DEG(theta1) <<  "  T2 = " << RAD2DEG(theta2) << "  T3 = " << RAD2DEG(theta3) << endl;
        pAgent.frontJointAngles(x,y,z, theta1,theta2,theta3);
        cout << " T1 = " << RAD2DEG(theta1) <<  "  T2 = " << RAD2DEG(theta2) << "  T3 = " << RAD2DEG(theta3) << endl;
    }
}
#endif

int main(){
    cout << "Offline Actuator is running " << endl;
    AtomicAction action;
    string lastCmd, cmd;
    int nstep;

    initialize();

    /*
    testPWalk();
    return 0;
    */

    while (1){
        cout << "Enter Command: " ;
        lastCmd = cmd;
        cin >> cmd;
        if (cmd == "Input" || cmd == "in"){
            //17 parameters
            cin >> action.walkType >> action.Forward >> action.Left >> action.turnCCW >> action.speed >> action.hF >> action.hB >> action.hdF >> action.hdB >> action.ffO >> action.fsO >> action.bfO >> action.bsO >> action.headType >> action.panx >> action.tilty >> action.cranez; 
            actionPro.execute(action);
            cout << "Params set " ;
            action.printFull();
        }
        else if (cmd == "ContinueStep" || cmd == "cs" ){
            actionPro.ContinueStep();
        }
        else if (cmd == "ContinueNStep" || cmd == "cns"){
            cin >> nstep;
            for (int i=0;i<nstep;i++)
                actionPro.ContinueStep();
        }
        else if (cmd == "Last Command" || cmd == "lc"){
            for (int i=0;i<nstep;i++)
                actionPro.ContinueStep();
        }
        else if (cmd == "Quit" || cmd == "qt"){
            break;
        }
        else if (cmd == "Default" || cmd == "df" ){
            action.cmd = aaParaWalk;
            action.walkType = NormalWalkWT;
            action.Forward = 7;
            action.Left = 0;
            action.turnCCW = 0;
            action.speed = 40;
            action.hF = 90;
            action.hB = 120;
            action.hdF = 10;
            action.hdB = 25;
            action.ffO = 55;
            action.fsO = 15;
            action.bfO = -55;
            action.bsO = 5;
            action.headType = ABS_H;
            action.panx = 0;
            action.tilty = 0;
            action.cranez = 0;
            actionPro.execute(action);
            cout << "Params set " ;
            action.printFull();
        }
        else if (cmd == "WalkType" || cmd == "wt"){
            cin >> action.walkType >> action.Forward >> action.Left >> action.turnCCW;
            actionPro.execute(action);
            cout << "You chose walktype " << walkTypeToStr[action.walkType] << endl;
        }
        else
            cout << "Unknown command " << endl;
    }
    return 0;
}

