#ifndef CPLANEDISPLAY_H
#define CPLANEDISPLAY_H
#include "FormCPlaneDisplay.h"
#include "CPlane.h"
#include "SimpleServer.h"

#include <qpixmap.h>
#include <qobject.h>
#include <qtimer.h>
#include <qpaintdevice.h>
#include <qimage.h>
#include <qlabel.h>
#include <qsocket.h>
#include <qlineedit.h>
#include <qlcdnumber.h>
#include <qfile.h>

#include <string>
#include <vector>
#include <fstream>

using namespace std;

struct OPlane{
    int objNum;
    int x;
    int y;
    int w;
    int h;
    int d;
};

class CPlaneDisplay : public FormCPlaneDisplay
{
    Q_OBJECT

public:
    CPlaneDisplay( const char * logFileName, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    bool loadFromFile(const string &fileName);
    //void paintEvent(QPaintEvent *paintEvent);
    int playBackLength();
    ~CPlaneDisplay();

public slots:
    void slotBack();
    void slotStop();
    void slotForward();
    void slotAnimate();
    void slotConnect();
    void slotListen();
    void slotToggleLogging();
    bool close(bool);
    void slotChangeCurrentObject(int item);
    
    void slotChangeUpdatingCPlane( int state );

//TODO do i need to do this?
private slots:
    void playNext();
    void readRemoteCPlane();
    void newConnection(ClientSocket *);

private:
    void displayCPlane(char *cplaneComressed, int size);
    void displayObjects(char *objectData, int size);
    void parseSensorsSanityObjects(char *data, int size);
    void parseCPlaneInState();
    int* displayObjectFieldValues(int *p);
    void displaySeenObjectOnGUI(vector<OPlane> &seenObject);

    string version;
    vector<CPlane *> frames;
    QPixmap *pixmap;
    int currentFrame;
    QSocket *clientSocket;
    SimpleServer *serverSocket;
    QTimer *timer;
    bool bLogToFile;
    QFile fLogFile;
    string logFileName;
    int currentObject;

    vector<QCheckBox*> objectCheckBoxes ;
};

#endif // CPLANEDISPLAY_H
