from qt import *
from FormCalibraterInfo import FormCalibraterInfo

class CalibraterInfo(FormCalibraterInfo):
    def __init__(self,parent = None,name = None,fl = 0):
        FormCalibraterInfo.__init__(self,parent,name,fl)
        self.parent = parent
        self.initMemberVariables()
        self.initLogFile()
        
    def initMemberVariables(self):
        self.bStarted = False
        
    def initLogFile(self):
        f = open(str(self.ledFileName.text()),"w")
        f.close()
        
    def slotGotNewMessage(self,msg):
        f = open(str(self.ledFileName.text()),"a")
        f.write("%s %s\n" % (str(self.ledDistance.text()),msg))
        f.close()
        self.ledBlobArea.setText(msg)
        
    def slotStartStopSending(self):
        print "CalibraterInfo.slotStartStopSending(): "
        msg = "__03pyc__091 area %d" % self.bStarted
        self.parent.slotServerSend(msg)
        
        if not self.bStarted:
            self.btStartStop.setText("Stop")
        else:
            self.btStartStop.setText("Start")
        self.bStarted = not self.bStarted
        
    def slotReset(self):
        self.bStarted = True
        self.slotStartStopSending()
        self.initLogFile()
        
def run(argv):
    a = QApplication(argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
   
    w = CalibraterInfo()
    a.setMainWidget(w)
    w.show()
    a.exec_loop()

if __name__ == "__main__":
    run(sys.argv)
