import random #psedo-random generator
from Vector import * #my module 
import math

def sum(aList):
    total = 0
    for v in aList:
        total += v
    return total
        
def getMean(values):
    return float(sum(values)) / len(values)

def getStandardDeviation(values):
    m = getMean(values)
    sq = map( lambda x: (x-m)**2 , values)
    sumSQ = sum(sq) / len(values)
    return math.sqrt(sumSQ)

class LearnError:   
    def __init__(self, startFromScratch = True, logFileName = "learnError.log"):
        self.parameters = None
        self.deltaParams = None
        self.evaluation = []
        self.logFileName = logFileName
        self.fd = open(logFileName,"w")
        self.fd.write("Evaluation of the same\n")
        self.fd.close()
        
    def setParameters(self,parameters):
        self.parameters = parameters
    
    def setDeltaParameters(self,deltaParams):
        self.deltaParams = deltaParams
        
    def getCurrentParameters(self):
        return self.parameters
        
    def getNextEvaluation(self):
        return (0,self.parameters)
        
    def setEvaluation(self,id,value):
        self.evaluation.append(value)
        self.fd = open(self.logFileName,"a")
        self.fd.write("%.2f\n"%value)
        self.fd.close()
        
    def cancelEvaluation(self,policyID):
        pass
            
    def getBestParameter(self):
        return ( "n = %d , mean = %.2f , sd = %.2f" % 
            (len(self.evaluation), getMean(self.evaluation), getStandardDeviation(self.evaluation)), 
            "%.2f"%max(self.evaluation)  )
        
    
