import math

def toDouble(list): #convert everything to float
    return map(float , list)
    
EPSILON = 0.00001

class Vector:
    def __init__(self,list):
        self.vector = toDouble(list) #make sure every element is double
        
    def length(self):
        total = 0.0
        for x in self.vector:
            total += x * x
        return math.sqrt(total)
        
    def standardize(self):
        l = self.length()
        if abs(l) < EPSILON: return
        
        self.vector = [ x / l for x in self.vector ]
        
    def multiply(self, constant):
        self.vector = [x * constant for x in self.vector]
    
    def multiplyVector(self, otherVec):
        self.vector = [x * y for x,y in zip (self.vector, otherVec) ]
            
    def add(self,otherVec):
        self.vector = [x + y for x,y in zip (self.vector, otherVec) ]
        
    def toList(self):
        return self.vector
