#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: GetBehindBall.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#
#   GetBehindBall.
#===============================================================================

"""
GetBehindBall testing 
"""

import math
import Global
import Constant
import HelpShort
import HelpLong
import HelpTrack
import ActiveLocalise

##~ lastBallY = 0
##~ lastBallX = 0

def getBestTurnDirection(attackAngle):
    if HelpShort.normalizeAngle_180(Global.selfLoc.getHeading() - attackAngle) < 0:
        return Constant.dANTICLOCKWISE
    else:
        return Constant.dCLOCKWISE
        
def getBehindBall(safetyDistance, attackAngle, turnDir, stepBack = False, startdist = 60, forwardFactor = 1.5):    
    if turnDir == Constant.dAUTO:
        turnDir = getBestTurnDirection(attackAngle)
    # The pivot point should be the vision ball.
##~     if Global.ballSource != Constant.VISION_BALL:
##~         return
##~     global lastBallX, lastBallY
##~     global ballToMe, attackPosX, attackPosY,attackPosD, attackPosH ,targetX, targetY,targetD, targetH,forward, turnCCW, left

##~     if (Global.ballSource == Constant.VISION_BALL):
##~         pivotX    = Global.ballX
##~         pivotY    = Global.ballY
##~         pivotH    = Global.ballH
##~         lastBallX = Global.ballX
##~         lastBallY = Global.ballY
##~ 
##~     #elif (Global.lostBall < Constant.VBALL_LOST):
##~     else:
##~         pivotX = lastBallX
##~         pivotY = lastBallY
##~         selfX,selfY = Global.selfLoc.getPos()
##~         selfH       = Global.selfLoc.getHeading()
##~         pivotH = HelpShort.normalizeAngle_180(HelpShort.getHeadingBetween\
##~         (selfX, selfY, lastBallX, lastBallY) - selfH)

    pivotX = Global.ballX
    pivotY = Global.ballY
    pivotH = Global.ballH
    
    ballToMe = HelpShort.getHeadingBetween(pivotX, pivotY, \
                    Global.selfLoc.getPos()[0], Global.selfLoc.getPos()[1])
                    
    #print "ballToMe: %f\n" % ballToMe
                    
    attackPosX, attackPosY = HelpShort.getPointRelative(pivotX, pivotY, \
                             HelpShort.normalizeAngle_180(attackAngle + 180), \
                             safetyDistance)
                             
    #print "attackPosX: %f\n" % attackPosX
    #print "attackPosY: %f\n" % attackPosY
                             
    attackPosD, attackPosH = HelpShort.findAngleDist(attackPosX, attackPosY)
    
    #print "attackPosD: %f\n" % attackPosD
    #print "attackPosH: %f\n" % attackPosH
    
    targetX, targetY = [-1, -1]
    
    if turnDir == Constant.dCLOCKWISE:
        #print "r\n"
        targetX, targetY = HelpShort.getPointRelative(pivotX, pivotY, \
                           HelpShort.normalizeAngle_180(ballToMe - 70), \
                           safetyDistance)
    else:
        #print "h\n"
        targetX, targetY = HelpShort.getPointRelative(pivotX, pivotY, \
                           HelpShort.normalizeAngle_180(ballToMe + 70), \
                           safetyDistance)
                    
    #print "targetX: %f\n" % targetX
    #print "targetY: %f\n" % targetY
    
    targetD, targetH = HelpShort.findAngleDist(targetX, targetY)
    forward, turnCCW, left = (-1.25, -1.25, -1.25)

    # Need to add stepBack here.
    
    if targetD > startdist:
        ##print "Far ",targetD, targetH
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = list(Constant.EllipticalWalkFast[Constant.AACmd:Constant.AAHeadType])
        turnCCW = HelpShort.CLIP(0.5 * targetH, 15)
        left = 0
        forward = 7
    else:
        if (targetD < attackPosD):
            #print "ttttt\n"
            turnCCW = HelpShort.CLIP(0.5 * pivotH, 20)
            forward = HelpShort.CLIP(targetD, 6.5) * math.cos(HelpShort.DEG2RAD(targetH * forwardFactor))  # 6.5 rather than 5.0 and 
            desLeft = targetD * math.sin(HelpShort.DEG2RAD(targetH))                             # no factor for the targetH
        else:
            #print "aaaaaaaaaa\n"
            turnCCW = HelpShort.CLIP(pivotH / 2.0, 20)
            forward = HelpShort.CLIP(attackPosD, 6.5) * math.cos(HelpShort.DEG2RAD(attackPosH))
            desLeft = attackPosD * math.sin(HelpShort.DEG2RAD(attackPosH))
            
        if abs(forward) < 3:
            left = HelpShort.CLIP(desLeft,6.6)
        else:
            left = HelpShort.CLIP(desLeft,5.5)
            
    ##~     print forward, left, turnCCW
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = list (Constant.NormalWalkSideWayFast[Constant.AACmd:Constant.AAHeadType])
      
    if stepBack:
        forward = forward - 10
##~         if forward < -6:
##~             forward = -6
      
    HelpLong.setForwardLeftTurn(forward,left,turnCCW)  
    
def DecideNextAction():
    Global.frameReset()
    HelpLong.superDebug()
    getBehindBall(40, 90, Constant.dCLOCKWISE)
    if Global.ballD > 50:
        if Global.frame % 30 < 10:
            ActiveLocalise.SmartSetBeacon(90,500)
            ActiveLocalise.DecideNextAction()
        else:
            HelpTrack.trackVisualBall()
    else:
        HelpTrack.trackVisualBall()
        
##~     print "%.2f   %.2f   %.2f" % tuple(Global.finalAction[Constant.AAForward:Constant.AAPg])
