#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: GoAndDoHeadKick.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#===============================================================================

"""
Vladmir Kramnik.
"""

import HoverToBall
import HeadKick
import FWHead
import Global
import HelpLong
import HelpShort
import OpenChallenger

RUNNING_TO_THE_BALL        = 0

# Dummy State. Don't know what this really mean.
ds = OpenChallenger.SuccessfulState()

# A wrapped grab ball implementation from OpenChallenger.
doRunToGrabBall = OpenChallenger.RunToGrabBall()

lockHeadKick = False

# If this function returns True, then the skill is not finished. The skill is finished when False is
# returned.
def goAndDoHeadKickWithGrabbing():
    global myState, RUNNING_TO_THE_BALL, DO_HEAD_KICK, lockHeadKick
    
    if lockHeadKick:
        if not HeadKick.headKickLeft():
            lockHeadKick = False
        else:
            return

    FWHead.resetEachFrame()
    FWHead.DecideNextAction()    
    grabSuccess = doRunToGrabBall.DecideNextAction()
    doRunToGrabBall.setOutState(ds)

    if grabSuccess == ds:
        lockHeadKick = True
        HeadKick.headKickLeft() # Or right

def goAndDoHeadKickWithoutGrabbing():
    global myState, RUNNING_TO_THE_BALL, DO_HEAD_KICK, lockHeadKick
    
    if lockHeadKick:
        HelpLong.setNormalWalk(0, 0, 0)
        if not HeadKick.headKickRight():
            lockHeadKick = False
        else:
            return

    if HelpShort.canSeeBall():
        HoverToBall.DecideNextAction()
    else:
        HelpLong.setNormalWalk(0, 0, 0)
    
    FWHead.resetEachFrame()
    FWHead.DecideNextAction()    
    
    if HeadKick.isHeadKickOk():
        lockHeadKick = True
        HeadKick.headKickRight() # Or left
    
def DecideNextAction():
    Global.frameReset()
    OpenChallenger.resetEachFrame()
##~     Global.finalAction[Constant.AAFfo] = 20

    goAndDoHeadKickWithoutGrabbing()
    HelpLong.superDebug()
