#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: GrabBall.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




"""
Grab ball behaviours
"""

import Global
import HelpLong
import HelpShort
import HelpTrack
import HoverToBall
import Constant
import VisionLink

MOUTH_OPEN = -1000000
MOUTH_CLOSE = -100000
FULL_MOUTH_OPEN_TIME = 15
STUCK_THRESHOLD = 10000
mouthOpenningTime = -1
def openMouth(angle):
    global mouthOpenningTime
    mouthOpenningTime += 1
    Global.finalIndicators[Constant.iMouth] = angle
    
def closeMouth():
    global mouthOpenningTime
    mouthOpenningTime = -1
    Global.finalIndicators[Constant.iMouth] = MOUTH_CLOSE
    
holdingBall = False
holdingCounter = 0

NOTHING = 0
HOLDING_BALL = 1
HOVERING_TO_BALL = 2
LOSING_BALL = 3
GRABBING_FINISHED = 4
GRABBING_STATE_DONE = 5

grabbingState = NOTHING

SLOW_DOWN_THRESHOLD = 20
SHOULD_NOT_SEE_BALL_TIME = 25
GRABBING_DISTANCE = 14
HOLDING_MAX_TIME = 30
GRABBING_MAX_TIME = 2 * HOLDING_MAX_TIME
isChinPressed = False
CHIN_SENSOR_DELAY = 5

def DecideNextAction():
    global holdingBall, holdingCounter, grabbingState,isChinPressed
    Global.frameReset() #just to make sure
    
    HelpLong.showRedEye(True)
        
    Global.frameReset() #just to make sure
    HoverToBall.DecideNextAction()
    grabbingState = HOVERING_TO_BALL
##~     if Global.ballD < SLOW_DOWN_THRESHOLD:
##~         Global.finalAction[Constant.AAWalktype] = Constant.NormalWalkWT
##~         Global.finalAction[Constant.AAForward] = HelpShort.CLIP(Global.finalAction[Constant.AAForward],3)
##~         
    if Global.haveBall > 0 :
        if holdingCounter > SHOULD_NOT_SEE_BALL_TIME:
            HelpLong.showRedEye(True)
            holdingBall = False
            holdingCounter = 0
            grabbingState = LOSING_BALL
        if Global.vBall.getVobDistance() < GRABBING_DISTANCE:
            if not holdingBall: 
                holdingCounter = 0
            holdingBall = True 
            grabbingState = HOLDING_BALL
    if holdingBall:
        HelpLong.setNormalWalk(0,0,0)
        if holdingCounter == 0:
            print "Stop"
            HelpLong.setForceStepComplete()
        if VisionLink.getAnySensor(1) > 0:
            isChinPressed = True
        grabbingState = HOLDING_BALL
##~         HelpLong.setNormalWalk(3,0,0)
        holdingCounter += 1
        HelpLong.setHeadParams(0,-70,50,Constant.HTAbs_h)
##~         if Global.degTilt - (-60) < 10: #start openning mouth
##~             openMouth(MOUTH_OPEN)
##~         if mouthOpenningTime > FULL_MOUTH_OPEN_TIME:
##~             if VisionLink.getAnySensor(0) - MOUTH_OPEN < STUCK_THRESHOLD:
##~                 holdingBall = False 
##~                 holdingCounter = 0
##~                 grabbingState = LOSING_BALL
##~             else:
##~                 Global.finalAction[Constant.AAWalktype] = Constant.UpennLeftWT
##~             HelpLong.showRedEye(grabbingState == LOSING_BALL)
##~             closeMouth()
        if holdingCounter > CHIN_SENSOR_DELAY:
##~             if not isChinPressed:
##~                 holdingBall = False 
##~                 holdingCounter = 0
##~                 grabbingState = LOSING_BALL
            if not isChinPressed:
                print "Red eye"
                HelpLong.showRedEye(True)
    
        if holdingCounter > HOLDING_MAX_TIME :
            grabbingState = GRABBING_FINISHED
            
        if holdingCounter > GRABBING_MAX_TIME:
            holdingBall = False
            holdingCounter = 0
            grabbingState = GRABBING_STATE_DONE
    else:
        isChinPressed = False
##~         closeMouth()
        HelpTrack.trackVisualBall()
    
    if Global.lostBall > 120 :
        HelpLong.setHeadParams(0,0,0,Constant.HTAbs_h)
        return
############### Testing, developing, experimenting #######

holdingBall = False
holdingCounter = 0

def testGrabBall():
    global holdingBall, holdingCounter
    Global.frameReset()
    HoverToBall.DecideNextAction()
    if Global.ballD < 20:
        Global.finalAction[Constant.AAForward] = HelpShort.CLIP(Global.finalAction[Constant.AAForward],3)
        
    if Global.haveBall > 0 and holdingCounter > 25:
        HelpLong.showRedEye(True)
        holdingBall = False
        holdingCounter = 0
        
    if Global.ballD < 10:
        if not holdingBall: 
            holdingCounter = 0
        holdingBall = True 
    if holdingBall:
        HelpLong.setNormalWalk(3,0,0)
        holdingCounter += 1
        HelpLong.setHeadParams(0,-60,50,Constant.HTAbs_h)
        if holdingCounter > 30 :
##~             HelpLong.setHeadParams(0,0,0,Constant.HTAbs_h)
            Global.finalAction[Constant.AAWalktype] = Constant.ChestPushWT
        if holdingCounter > 30 * 2:
            holdingBall = False
            holdingCounter = 0
    else:
        HelpTrack.trackVisualBall()
    
