#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: HeadForwardKick.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




import Debug
import Global
import Constant
import HelpLong

timer               = 0
PAW_OUT             = (Constant.aaParaWalk, Constant.BackWalkWT, 0, 0, 0, 5, 20, 40, 10, 45, 145, \
                        -15, -70, 20, Constant.HTAbs_h, 0, 0 ,0)
lockHeadForwardKick = False
           
def headForwardKick():
    global timer, PAW_OUT

    timer += 1
    temp = 3
    
    if timer <= temp:
        HelpLong.setHeadParams(0, 0, 0, Constant.HTAbs_h)
        return True
    
    elif timer <= (temp * 2):
        HelpLong.setHeadParams(80, 0, 0, Constant.HTAbs_h)
        return True
        
    elif timer <= (temp * 4):
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = \
                list(PAW_OUT[Constant.AACmd:Constant.AAHeadType])    
        HelpLong.setHeadParams(80, -60, -20, Constant.HTAbs_h)
        return True
        
    elif timer <= (temp * 5):
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = \
                list(PAW_OUT[Constant.AACmd:Constant.AAHeadType])        
        HelpLong.setHeadParams(-80, -60, 40, Constant.HTAbs_h)
        return True
    
    else:
        timer = 0
        return False

def DecideNextAction():
    global lockHeadForwardKick
    
    if lockHeadForwardKick:
        lockHeadForwardKick = headForwardKick()
        return

    if Debug.doHeadKick or True:
        Debug.doHeadKick = False
        lockHeadForwardKick = headForwardKick()
