#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: HeadTest.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#
# Forward.py
#
# Our rUNSWift 2004 Forward Player!!
#
#===============================================================================

"""
HeadTest: test head kinematics and inverseKinematics
"""

##~ import Kick
import FWHead
import Global
import Constant
import HelpLong
import HelpTrack
import VisionLink

#==================================================================
# Functions belong to this module.
#===============================================================================

lowX = -100
lowY = -10
highX = 100
highY = 100

lastX = lowX
lastY = lowY

deltaX = 5
deltaY = 5

delay = 0
maxDelay = 15

def testProject():
    global lastX, lastY, lowX, lowY, highX, highY, deltaX, deltaY, delay, maxDelay

    resetEachFrame()
    
    Global.lastHeadType = Global.finalAction[Constant.AAHeadType] = Constant.HTAbs_xyz
    Global.lastTilt     = Global.finalAction[Constant.AATilty]    = 0
    Global.lastPan      = Global.finalAction[Constant.AAPanx]     = lastX
    Global.lastCrane    = Global.finalAction[Constant.AACranez]   = lastY
    
    delay += 1
    if delay > maxDelay:
        delay = 0
        ppt = VisionLink.getProjectedPoint(0, 0);
        print "aimX: "
        print lastX
        print " aimY: "
        print lastY
        print " projXY: "
        print ppt
        print "\n"
        lastX += deltaX
        if lastX > highX:
            lastX = lowX
            lastY += deltaY
        if lastY > highY:
            lastY = lowY

def testTrackBall():
    resetEachFrame()
    HelpTrack.trackVisualBall()
    
        
def DecideNextAction():

    if (Global.debugBehaviour_line):
        print "..... new frame: ", Global.frame

    Global.frameReset()

    # testProject()
    testTrackBall()

    # Show debug information using head lights.
    HelpLong.superDebug()

    
#--------------------------------------
# General Initialisation
def resetEachFrame():

    # Get the 2004 DKD range.
    Global.DKD      = HelpTrack.getDKDRange()
    Global.myRole   = Constant.NOROLE

    HelpLong.setDefaultAction()
    HelpLong.setDefaultIndicators()

    FWHead.resetEachFrame()
