#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: HoverToBall.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#===============================================================================


"""
HoverToBall
"""

import math
import Global
import Constant
import HelpLong
import HelpWhere
import HelpShort
import HelpTrack
import FWHead
##~ import VisionLink
import StealthDog

##~ lastBallY = 0
##~ lastBallX = 0

##~ #--------------------------------------
##~ # Called by Attacker - do HoverToBall only in edege/corner cases and heading is wrong.
##~ def shouldIHoverToBall():
##~ 
##~     returnVal = False
##~ 
##~     # Heading wrong and in right edge.
##~ ##~     if ((HelpWhere.isInRange(0, 70) 
##~ ##~             or HelpWhere.isInRange(290, 360))
##~ 
##~     if ((HelpWhere.isInRange(0,50) or HelpWhere.isInRange(310, 360))
##~             and HelpWhere.isOnREdge() ):
##~ ##~             and abs (Global.ballH) > 60):
##~         
##~         returnVal = True
##~     
##~     # Heading wrong and in left edge. 
##~ ##~     elif (HelpWhere.isInRange(110, 250)
##~     elif (HelpWhere.isInRange(130, 230)
##~             and HelpWhere.isOnLEdge() ):
##~ ##~             and abs (Global.ballH) > 60):
##~ 
##~         returnVal = True
##~         
##~     # Heading wrong in top edge.
##~ ##~     elif (HelpWhere.isInRange(20, 160)
##~     elif (HelpWhere.isInRange(40, 140)
##~             and HelpWhere.isOnTEdge() ):
##~ ##~             and abs (Global.ballH) > 60):
##~ 
##~         returnVal = True
##~ 
##~     # bottom edge
##~ ##~     elif (HelpWhere.isInRange(200,340)
##~     elif (HelpWhere.isInRange(220,320)
##~         and HelpWhere.isOnBEdge() ):
##~ ##~         and abs (Global.ballH) > 60):
##~         
##~         returnVal = True
##~         
##~     return returnVal

#--------------------------------------
# Hover to ball. Approach the ball expecting the ball is under chin when the ball is close.
def DecideNextAction(dist = 0, head = 0):

    if StealthDog.stealthDog(True):
        FWHead.compulsoryAction = FWHead.mustSeeBall    # This line is for FWHead
        HelpTrack.trackVisualBall()
        return

    # Uncomment the following if any souce is acceptable
    ##~     if (Global.ballSource != Constant.VISION_BALL):
    ##~         return

    HelpLong.showFacePattern(Constant.FP_HOVER_TO_BALL)
    
    if dist != 0 and head != 0:
        ballD = dist
        ballH = head
    
##~     global lastBallX, lastBallY

##~     if (Global.ballSource == Constant.VISION_BALL):
##~         ballH     = Global.ballH
##~         ballD     = Global.ballD
##~         lastBallX = Global.ballX
##~         lastBallY = Global.ballY
##~ 
##~     #elif (Global.lostBall < Constant.VBALL_LOST):
##~     else:
##~         selfX,selfY = Global.selfLoc.getPos()
##~         selfH       = Global.selfLoc.getHeading()
##~         ballH = HelpShort.normalizeAngle_180(HelpShort.getHeadingBetween\
##~         (selfX, selfY, lastBallX, lastBallY) - selfH)
##~         ballD = HelpShort.getDistanceBetween(lastBallX, lastBallY, selfX, selfY)
    else:
        ballD = Global.ballD
        ballH = Global.ballH
    
    # more cases for wireless and gps ball is here
    
    # Do only turn if the heading is too large, so that dog will not stuck in edges.
    if abs(ballH) > 40:
        HelpLong.setNormalWalk(0,0,HelpShort.CLIP(ballH,35))
        return
    
    HelpLong.setEllipticalWalk(0,0,0)
    
    slowDownDistance = 30
    if HelpWhere.isInRange (5,175):
        slowDownDistance = 20
        
    slowDown = ballD < slowDownDistance
        
    headingLarge = abs(ballH) > 15

    # print "HoverToBall.py - DecideNextAction() not tuned well!"

    # Unless the robot want to grab the ball or control it directly. HoverToBall shouldn't slow down
    # the robot at all.
    #
    if slowDown and headingLarge:    
        HelpLong.setForwardLeftTurn(3,3,HelpShort.CLIP(ballH / 1.6,30.0))
    
    if slowDown and not headingLarge:
        HelpLong.setForwardLeftTurn(7,0,HelpShort.CLIP(ballH / 2.0,30.0))

    if not slowDown and headingLarge:
        HelpLong.setForwardLeftTurn(4,0,HelpShort.CLIP(ballH / 1.6,30.0))

    if not slowDown and not headingLarge:
        # Use the fastest walk when ball is far away.
        turnCCW = HelpShort.CLIP(ballH / 2.0, 30.0)
        HelpLong.setForwardLeftTurn(7,0,turnCCW)
##~         if ballD > 70:
##~             HelpLong.setEllipticalWalk(7,0,turnCCW)
##~         else:
##~             HelpLong.setNormalWalk(7,0,turnCCW)
##~             HelpLong.setForwardLeftTurn(7,0,turnCCW)



# Move to specifed position given the global coordinative.
# This version is the "fast" version of the one in the HelpTrack
def saGoToTargetFacingHeading(targetX, targetY, targetH, maxSpeed = 7, maxTurn = 30):

    # ariables relative to self localisation.
    selfX     = Global.selfLoc.getX()
    selfY     = Global.selfLoc.getY()
    selfH     = Global.selfLoc.getHeading()
    relX      = targetX - selfX
    relY      = targetY - selfY
    relH      = HelpShort.normalizeAngle_180(targetH - selfH)
    relX     += Constant.DOG_LENGTH/2.0/10.0*(math.cos(math.radians(selfH)) - math.cos(math.radians(targetH)))
    relY     += Constant.DOG_LENGTH/2.0/10.0*(math.sin(math.radians(selfH)) - math.sin(math.radians(targetH)))
    relD      = HelpShort.getLength((relX, relY))
    distance  = HelpShort.getDistanceBetween(targetX, targetY, selfX, selfY)
    inCircle  = distance <= 40
    faceH     = HelpShort.getHeadingToFaceAt(targetX, targetY)
    
##~     print "faceH: ", faceH
    
    if not inCircle:
        if abs(faceH) >= 30:
            HelpLong.setNormalWalk(0, 0, HelpShort.CLIP(faceH, maxTurn))
        else:
            if StealthDog.stealthDog(True):
                FWHead.compulsoryAction = FWHead.mustSeeBall
                HelpTrack.trackVisualBall()
                return
            HelpLong.setEllipticalWalk(7, 0, HelpShort.CLIP(faceH/1.5,maxTurn))
        
    else:
        if relX == 0 and relY == 0:
            # On the dog, math.atan2(0,0) give "Value Error: math domain error".
            relTheta = 0
        else:
            relTheta = HelpShort.normalizeAngle_180(HelpShort.RAD2DEG(math.atan2(relY, relX)) - selfH)
    
        forward  = HelpShort.CLIP(relD, maxSpeed) * math.cos(HelpShort.DEG2RAD(relTheta))
        left     = HelpShort.CLIP(relD, maxSpeed) * math.sin(HelpShort.DEG2RAD(relTheta))
        turnCCW  = HelpShort.CLIP(relH, maxTurn)
        HelpLong.setNormalWalk(forward, left, turnCCW)

# This version is the "fast" version of the one in the HelpTrack
def saGoToTarget(targetX, targetY, maxSpeed = 7, maxTurn = 30):

    selfX, selfY = Global.selfLoc.getPos()
    selfH        = Global.selfLoc.getHeading()
    relX         = targetX - selfX
    relY         = targetY - selfY
    relD         = HelpShort.getLength((relX, relY))
    distance     = HelpShort.getDistanceBetween(targetX, targetY, selfX, selfY)
    inCircle     = distance <= 40
    faceH        = HelpShort.getHeadingToFaceAt(targetX,targetY)
    
    if not inCircle and abs(faceH) >= 30:
        HelpLong.setNormalWalk(0, 0, HelpShort.CLIP(faceH, maxTurn))
        
    elif not inCircle:
        
        if StealthDog.stealthDog(True):
            FWHead.compulsoryAction = FWHead.mustSeeBall
            HelpTrack.trackVisualBall()
            return
            
        HelpLong.setEllipticalWalk (7,0,HelpShort.CLIP(faceH/1.5,maxTurn))
        
    else:
        if relX == 0 and relY == 0:
            relTheta = 0
        else:
            relTheta = HelpShort.normalizeAngle_180(HelpShort.RAD2DEG(math.atan2(relY, relX)) - selfH)
        
        forward  = HelpShort.CLIP(relD, maxSpeed) * math.cos(HelpShort.DEG2RAD(relTheta))
        left     = HelpShort.CLIP(relD, maxSpeed) * math.sin(HelpShort.DEG2RAD(relTheta))
        turnCCW  = HelpShort.CLIP(relTheta, maxTurn)
        HelpLong.setNormalWalk(forward, left, turnCCW)
