#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: LabArchive.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#Collection of experimental codes. May be out-of-date, 
#Move tested stuff here to keep TestingP clean and fresh.
#Please don't modify other's code here. Just add new stuff in

import Global
import VisionLink 
import HelpLong
import HelpShort
import HelpTrack
import HoverToBall
import Constant
import ActiveLocalise
from StateBasedAction import StateBasedAction
import WalkingSkills
import OpenChallenger
import Debug

##################  testStoppingDog #############
### Get the dog runs very fast, stopping using forceStepComplete
### grab the ball using head, and kick using my kick
### ::Work very fine, except the trackVisualBall is bad,
### will come back after fixing it.

aproaching = False
grabbingBall = False
trueDistance = 50.0

STOP_POINT = 10.0
SLOW_DOWN_POINT = 30.0
MAX_FORWARD_SPEED = 7.0

def testStoppingDog():
    global aproaching,trueDistance,grabbingBall
    HelpLong.showFacePattern([0,0,0,0,0])
    if grabbingBall:
        HelpLong.showFacePattern([1,0,0,0,1])
        if Global.lostBall > 50:
            grabbingBall = False
        elif Global.lostBall > 10:
            Global.finalAction[Constant.AAWalktype] = Constant.ChestPushWT
        else:
            HelpLong.setHeadParams(0,-70,50,Constant.HTAbs_h)
##~         if Global.haveBall >= 20:
##~             grabbingBall = False
    elif Global.lostBall == 0:
        HelpTrack.trackVisualBall()
        if aproaching:
            HelpLong.showFacePattern([2,0,0,0,2])
            if Global.ballD < trueDistance:
                trueDistance = Global.ballD
            if trueDistance <= STOP_POINT:
                HelpLong.setNormalWalk(0,0,0)
            else:
                tmp = (SLOW_DOWN_POINT - STOP_POINT)
                HelpLong.setNormalWalk( (trueDistance - STOP_POINT)/tmp * MAX_FORWARD_SPEED,0,\
                Global.ballH)
            HelpLong.setForceStepComplete()
            if Global.ballD > SLOW_DOWN_POINT + 20: #heteresis
                aproaching = False
            if Global.vBall.getVobDistance() < 11:
                grabbingBall = True
        if Global.ballD > 100:
            Global.finalAction[Constant.AAWalktype] = Constant.EllipseWalkWT
            HelpLong.setForwardLeftTurn(0,0,Global.ballH/2)
        elif Global.ballD > SLOW_DOWN_POINT:            
            Global.finalAction[Constant.AAWalktype] = Constant.NormalWalkWT
            HelpLong.setForwardLeftTurn(7,0,Global.ballH)
        else:
            aproaching = True
            trueDistance = 50.0
    
############### Example of using GrabBall module ####
import GrabBall
grabbingBall = False
FP_GRABBING = [1,0,0,0,1]
def doGrabbingBall():   
    global grabbingBall
    HelpLong.showFacePattern(FP_GRABBING)
    GrabBall.DecideNextAction()
    
    if GrabBall.grabbingState == GrabBall.GRABBING_FINISHED:
        print "Finish"
        Global.forceHighGain = True
        Global.finalAction[Constant.AAWalktype] = Constant.UpennRightWT
    if GrabBall.grabbingState == GrabBall.GRABBING_STATE_DONE:
        print "Yeah, done"
        grabbingBall = False

############### Testing how many step need to turn 180 degree####
turn180Counter = 0
NUMBER_OF_FRAME = 150

def testTurn180():
    global turn180Counter
    if turn180Counter < NUMBER_OF_FRAME:
        HelpLong.setNormalWalk(0,0,10)
        turn180Counter += 1
    elif turn180Counter == NUMBER_OF_FRAME:
        HelpLong.setNormalWalk(0,0,0)
        HelpLong.setForceStepComplete()
    else:
        HelpLong.setNormalWalk(0,0,0)
    
############### Test how good GPS can be                ####

def satisfiedLocalisationCondition():   
    return Global.selfLoc.getPosVar() < HelpShort.get95cf(25) and \
        Global.selfLoc.getHeadingVar() < HelpShort.get95cf(20)
       
myaGoingTo = Constant.dCLOCKWISE
alcounter = 0
STARING_TIME = 5
def doMyActiveLocalise():
    global myaGoingTo,alcounter
    #if current GPS is bad, then my will be wrong
    
    # Isn't HelpShort.get95cf(40) too small? Even when the gps is good,
    # often the getPosVar() return something like 700, but HelpShort.get95cf
    # (40) return only 400.
    if Global.selfLoc.getHeadingVar() > HelpShort.get95cf(80) or\
        Global.selfLoc.getPosVar() > HelpShort.get95cf(40):
        HelpTrack.stationaryLocalise()
    else:
        beaconPos = [(0,0),
            (Constant.FIELD_WIDTH,0),
            (Constant.FIELD_WIDTH,Constant.FIELD_LENGTH),
            (0,Constant.FIELD_LENGTH)]
        panAngle = []
        myX,myY = Global.selfLoc.getPos()
        myH = HelpShort.normalizeAngle_180( Global.selfLoc.getHeading() )
        for (x,y) in beaconPos:
            deg1 = HelpShort.getHeadingBetween( myX,myY,x,y) 
            panAngle.append( HelpShort.normalizeAngle_180(deg1 - myH ) )
        panAngle.sort(lambda x,y : cmp(abs(x) , abs(y) ) )
        panA,panB = panAngle[:2]
        if panA > panB:
            t = panA
            panA = panB
            panB = t
    
        if myaGoingTo == Constant.dCLOCKWISE:
            panx = panA
            if abs(Global.degPan - panx) <= 5:
                alcounter += 1
                if alcounter == STARING_TIME:
                    myaGoingTo = Constant.dANTICLOCKWISE
                    alcounter = 0
        else:
            panx = panB
            if abs(Global.degPan - panx) <= 5:
                alcounter += 1
                if alcounter == STARING_TIME:
                    myaGoingTo = Constant.dCLOCKWISE
                    alcounter = 0
        Debug.showDebug("panAngle = %s panA = %s panB = %s panx = %s " %(panAngle,panA,panB,panx))
        
        HelpLong.setHeadParams(panx,0,0,Constant.HTAbs_h)
    
smartLocaliseCounter = 0   
TIME_OUT = 4800
foundPosition = False

def resetSmartLocalise():
    global foundPosition, smartLocaliseCounter
    smartLocaliseCounter = 0
    foundPosition = False
    
def testSmartLocalise():
    global smartLocaliseCounter,foundPosition
    if smartLocaliseCounter > TIME_OUT:
        if foundPosition: 
            HelpLong.showFacePattern([3,2,2,2,3])
        else:
            HelpLong.showFacePattern([0,0,0,0,0])
        WagTail()
    elif not satisfiedLocalisationCondition():
        doMyActiveLocalise()
        smartLocaliseCounter += 1
    else:
        foundPosition = True
        smartLocaliseCounter = TIME_OUT
    

        
##################### ActiveLocalise testing#############################
wagTailCounter = 0
def WagTail():
    global wagTailCounter
    
    wagTailCounter = wagTailCounter + 1
    tailPos = ((wagTailCounter + 15) % 30 - 15) * 3
    if (wagTailCounter + 15) % 60 > 30:
        tailPos = -tailPos

    tailPos = HelpShort.NORMAL2MICRO(HelpShort.DEG2RAD(tailPos))
    Global.finalIndicators[Constant.iTailH] = tailPos
    Global.finalIndicators[Constant.iTailV] = Constant.IND_TAIL_UP

wagTail = False
    
def testActiveLocalise():
    global wagTail
    if wagTail:
        WagTail()
    else:
##~         HelpTrack.stationaryLocalise()
        ActiveLocalise.SmartSetBeacon(90,500)
        ActiveLocalise.DecideNextAction()
        if  Global.selfLoc.getPosVar() < HelpShort.get95cf(25)   and \
            Global.selfLoc.getHeadingVar() < HelpShort.get95cf(20):
                wagTail = True

############## Test grab ball with chin sensor #######################

def openMouth(angle):
    Global.finalIndicators[Constant.iMouth] = angle
    
mouthCounter = 0
MOUTH_OPEN = -1000000
STUCK_THRESHOLD = 10000
FP_BALL_UNDER_CHIN = [0,2,2,2,0]
FP_NOTHING_UNDER_CHIN = [3,0,0,0,3]
FP_OFF = [0,0,0,0,0]
OPEN_MOUTH_AFTER = 10
FULL_MOUTH_OPEN_TIME = 15

GrabBall.SLOW_DOWN_THRESHOLD = 20
GrabBall.SHOULD_NOT_SEE_BALL_TIME = 25
GrabBall.GRABBING_DISTANCE = 10
GrabBall.HOLDING_MAX_TIME = 60
GrabBall.GRABBING_MAX_TIME = 2 * GrabBall.HOLDING_MAX_TIME

def testGrabBallWithChinSensor():

    global mouthCounter 
    GrabBall.DecideNextAction()
##~     print "Stalte",GrabBall.grabbingState
    HelpLong.showRedEye(False)
    if GrabBall.grabbingState == GrabBall.HOLDING_BALL: 
        HelpLong.showRedEye(True)
        if mouthCounter >= OPEN_MOUTH_AFTER:
            openMouth(MOUTH_OPEN)
        if mouthCounter >= OPEN_MOUTH_AFTER + FULL_MOUTH_OPEN_TIME:
            if VisionLink.getAnySensor(0) - MOUTH_OPEN > STUCK_THRESHOLD:
                HelpLong.showFacePattern(FP_BALL_UNDER_CHIN)
                print "counter = ",mouthCounter
            else:
                HelpLong.showFacePattern(FP_NOTHING_UNDER_CHIN)
        mouthCounter += 1
    else:
        mouthCounter = 0
        openMouth(Constant.IND_MOUTH_CLOSED)
        HelpLong.showFacePattern(FP_OFF)
            

doGoToPosition = WalkingSkills.GoToPosition(200,350,0)

def test(no):
    if no == 0:
        desX = 150
        desY = 350
        desH = 270
    else:
        desX = 40
        desY = 50
        desH = 90
        
    doGoToPosition.targetX,doGoToPosition.targetY,doGoToPosition.targetH = desX,desY,desH
    doGoToPosition.beginAction()
    
doGrabBall = OpenChallenger.MyGrabBall()
doApproaching = OpenChallenger.ApproachingBall()
doKickBall = OpenChallenger.KickBall()

def testMyGrabBall():
    OpenChallenger.resetEachFrame()
    HelpTrack.trackVisualBall()
##~     print "chin",doGrabBall.isBallUnderChin()
    if doKickBall.shouldBeActivated() and doGrabBall.isBallUnderChin():
        print "KickBall"
        doKickBall.DecideNextAction()
    elif doGrabBall.shouldBeActivated():
        print "GrabBall"
        doGrabBall.DecideNextAction()
    elif doApproaching.shouldBeActivated():
        print "ApproachingBall"
        doApproaching.DecideNextAction()
    else:
        HoverToBall.DecideNextAction()
        
        
############## State Based kick aiming #######################
##~ 
##~ APPROACHING_DISTANCE = 25
##~ class KickAiming(StateBasedAction):
##~     def __init__(self):
##~         StateBasedAction.__init__(self)
##~         self.desiredHeading = 0
##~         self.kickAproaching = OpenChallenger.ApproachingBall(10,APPROACHING_DISTANCE)
##~         self.kickGrabBall = OpenChallenger.MyGrabBall()
##~         self.ballHoldingLocalise = OpenChallenger.BallHoldingLocalise()
##~         self.kickTurning = OpenChallenger.KickTurning()
##~         self.kickKicking = OpenChallenger.KickBall()
##~         
##~         self.kickAproaching.setOutState(self.kickGrabBall)
##~         self.kickGrabBall.setOutState(self.ballHoldingLocalise)
##~         self.ballHoldingLocalise.setOutState(self.kickTurning)
##~         self.kickTurning.setOutState(self.kickKicking)
##~ 
##~         self.debug = True
##~         
##~     def beginAction(self):
##~         self.desiredHeading = HelpShort.getHeadingBetween(*(myPos + teammatePos))
##~         print "Desired H = ",self.desiredHeading," My H = ",myHeading
##~         
##~     #idea: only use desision to make the state more upto date.
##~     def DoAction(self):
##~ 
##~         if self.subState is None: #decide if all of the sub state is not active
##~             if Global.lostBall == 0 and Global.ballD < APPROACHING_DISTANCE:
##~                 if self.debug: print "kick ApproachingBall"
##~                 self.doSubState(self.kickAproaching)
##~             if Global.lostBall == 0:
##~                 HoverToBall.DecideNextAction()
##~                 return self
##~             else:
##~                 HelpTrack.trackGpsBall()
##~                 return None
##~         else:
##~             if self.subState == self.kickAproaching and \
##~                 Global.lostBall == 0 and \
##~                 Global.vBall.getVobDistance() < 14 and\
##~                 abs(localBallX) < 4 :
##~                 if self.debug: print "kick GrabBall"
##~                 self.doSubState(self.kickGrabBall)
##~             else:
##~                 #Do normal state switching
##~                 self.doSubState()
##~             return self

##~ kickAimingAction = LabArchive.KickAiming()
##~ def testKickAiming():
##~     OpenChallenger.resetEachFrame()
##~     kickAimingAction.DecideNextAction()
##~     


############## IR tracking & utilisation  #######################
##~ irDistances = [1500000] * 5
##~ MAX_DISTANCE_FROM_THE_CENTER = 50
##~ IR_TRUST_DISTANCE = 120
##~ MAX_IR_DISTANCE = 150
##~ irOppHeading = 0
##~ 
##~ def calculateOpponentPositionFromIRSensor():
##~     global opponentPos,lastOppSeenTime,irOppHeading
##~     (x,y) = redBlobCenter
##~     x -= Constant.IMAGE_WIDTH / 2
##~     y -= Constant.IMAGE_HEIGHT / 2
##~     if HelpShort.getDistanceBetween(0,0,x,y) < MAX_DISTANCE_FROM_THE_CENTER: #the dog is near theh IR sensor
##~         d = min(irDistances)
##~         if d < IR_TRUST_DISTANCE:
##~             irOppHeading = Global.degPan 
##~             oppToMeHeading = HelpShort.normalizeAngle_0_360(myHeading + irOppHeading)
##~             opponentPos = HelpShort.getPointRelative(*(myPos + (oppToMeHeading,d)))
##~             
##~             Debug.showDebug("d = %d IR Pos = %s" % (d,str(opponentPos)) )
##~             lastOppSeenTime = Global.frame
##~         else:
##~             Debug.showDebug("ir too large %d" % d)
##~     else:        
##~         Debug.showDebug("not Focus on the robot : %d %d" % (x,y))
##~          

################ Get IR trusted distance #####
##~ #get opponent position, if irSensor is triggered, then trust that information for
##~     #a certain number of frame, otherwise, use GPS
##~     redBlobCenter = VisionLink.getRedBlobInfo()

##~     x,y = VisionLink.getProjectedPoint(0,0)
##~     if  x < MAX_IR_DISTANCE and y < MAX_IR_DISTANCE and \
##~         x*x + y*y < MAX_IR_DISTANCE*MAX_IR_DISTANCE: #the first two just to speed up
##~         irDistances.pop(0)
##~         irDistances.append(VisionLink.getAnySensor(5) / 10000.0)
##~     
##~     
distances = [1500000] * 15

def testRedDogTracking():
##~     
##~     x,y = VisionLink.getRedBlobInfo()
##~     
##~     if x != 0 or y != 0:
##~         x -= 104
##~         y -= 80
##~         x,y = VisionLink.getProjectedPoint(x,y)
##~         if x < 1000000 and y < 1000000:
##~             print "x,y = ", x,y
##~             HelpLong.setHeadParams( x, 0, y, Constant.HTAbs_xyz)
    distances.pop(0)
    distances.append(VisionLink.getAnySensor(5))
    x,y = VisionLink.getRedBlobInfo()
    if x != 0 or y != 0:
        x = VisionLink.PointToHeading(x*1.0) / 1.13
        y = VisionLink.PointToElevation(y*1.0) / 1.13
        HelpLong.setHeadParams( Global.degPan + x, 0, Global.degCrane + y, Constant.HTAbs_h)
        print "Distance =", min(distances)
STAT_LOC_SPEED = 5
def testSeeingDog():
    seeOpp = False
    seeTM = False
    HelpTrack.stationaryLocalise(STAT_LOC_SPEED)
    for dog in Global.vOpponents:
        if dog.getConfidence() > 0:
            seeOpp = True
    for dog in Global.vTeammates:
        if dog.getConfidence() > 0:
            seeTM = True
    if seeOpp and seeTM:
        HelpLong.showFacePattern([2,0,0,0,2])
    elif seeOpp:
        HelpLong.showFacePattern([3,0,0,0,0])
    elif seeTM:
        HelpLong.showFacePattern([0,0,0,0,3])
    else:
        HelpLong.showFacePattern([0,0,0,0,0])
    
#############################################################
###   Hold the ball and turn using BackWalk --> too slow
##~ 
##~ def setBackWalkTurnCCW(turnCCW):
##~     if turnCCW > 0: 
##~ ##~         print "BackWalk CCW"
##~         Global.finalAction = list(Constant.BackWalkCounterClockWise)
##~     else:
##~ ##~         print "BackWalk CW"
##~         Global.finalAction = list(Constant.BackWalkClockWise)
##~ 
##~ class KickTurningBackWalk(StateBasedAction):
##~     TURNING_LEFT_720 = 18.4
##~     TURNING_RIGHT_720 = 18.8
##~     TURNING_MOUTH_OPEN = -1000000
##~     CAN_CHECK_CHIN_TIME = 25
##~     FINISH_OPENNING_MOUTH = 10
##~     def __init__(self):
##~         StateBasedAction.__init__(self)
##~         self.turningTime = 0
##~         self.turnDir = 0
##~         
##~     def calculateTurningTime(self):
##~         turnNeeded = HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)
##~         print "Turn needed = ",turnNeeded," my H = ", myHeading
##~         
##~         if turnNeeded > 0:
##~             calibrate = self.TURNING_LEFT_720
##~             self.turnDir = Constant.dANTICLOCKWISE
##~         else:
##~             calibrate = self.TURNING_RIGHT_720
##~             self.turnDir = Constant.dCLOCKWISE
##~         self.turningTime = calibrate * 30 / (720.0/abs(turnNeeded))
##~         print "Turning time = ",self.turningTime
##~ 
##~     def beginAction(self):
##~         self.desiredHeading = HelpShort.getHeadingBetween(*(myPos + teammatePos))
##~         print "Desired H = ",self.desiredHeading," My H = ",myHeading
##~         HelpLong.setForceStepComplete()
##~         self.bHeadingRightDir = False
##~         self.calculateTurningTime()
##~         
##~         
##~     def finishAction(self):
##~         HelpLong.openMouth(Constant.IND_MOUTH_CLOSED)
##~         
##~     def DoAction(self):
##~         HelpLong.showFacePattern(FP_KICK_AIMING)
##~         setBackWalkTurnCCW(self.turnDir)
##~         
##~         HelpLong.setHeadParams(0, -45, 50,Constant.HTAbs_h)
##~         if self.counter > KickTurning.FINISH_OPENNING_MOUTH:
##~             HelpLong.openMouth(KickTurning.TURNING_MOUTH_OPEN)
##~             
##~         if Global.lostBall == 0:
##~             return None #see the ball while it should not
##~         elif self.counter > KickTurning.CAN_CHECK_CHIN_TIME:
##~             if VisionLink.getAnySensor(Constant.ssMOUTH) - KickTurning.TURNING_MOUTH_OPEN < MyGrabBall.STUCK_THRESHOLD:
##~                 return None #oops, sensed no ball under my mouth.
##~             
##~         if self.counter < self.turningTime:
##~             return self
##~         else:
##~             return self.outState
