#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: Odometer.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 





"""
Odometry testing stuff
"""

import HelpLong
import HelpTrack
import Constant
import OdoLearner
import Global

wirelessCommand = None

counter = 1000000 #not doing until being reset()
numOfFrames = 10000#30*5

FP_DOING        = [1, 1, 1, 1, 1]
FP_STOP        = [0, 0, 0, 0, 0]
walkCommand     = (0,0,0)
bStop           = False

def DecideNextAction():
    global counter, wirelessCommand,bStop,walkCommand
    Global.frameReset()
    HelpLong.setNormalSideWalk(0,0,0)
    HelpLong.setForceStepComplete()
    if bStop:
        print "Counter = ",counter
        bStop = False
        counter = numOfFrames
        
    if counter < numOfFrames:  
        counter += 1
        HelpLong.showFacePattern(FP_DOING)
        if len(walkCommand) != 3:
            walkCommand = (0,0,0) 
        Global.forceHighGain = True 
##~         HelpLong.setEllipticalWalk(*walkCommand) 
##~         HelpLong.setNormalWalk (*walkCommand)
        HelpLong.setNormalSideWalk(*walkCommand)
        HelpLong.setHeadParams(0,-45,-20, Constant.HTAbs_h)
    else:
        HelpLong.showFacePattern(FP_STOP)
    if wirelessCommand is not None:
        wirelessCommand()
    
def resetEverything():
    global counter 
    counter = 0
    df,dl,dt = walkCommand
##~     NormalWalk
##~     df /= (2 * Constant.NormalWalkSideWayFast[Constant.AAPg])
##~     dl /= (2 * Constant.NormalWalkSideWayFast[Constant.AAPg])
##~     dt /= (2 * Constant.NormalWalkSideWayFast[Constant.AAPg])

##~     EllipticalWalk
    df = 2.0 * 49 / 76
    dl = 0.064
    dt = dt / 76 + 0.0225
    print "One step = ", df, dl, dt
    print "After ", numOfFrames, " it should end up at ", \
        OdoLearner.getFinalPosition(0,0,0,df,dl,dt,numOfFrames)
    Global.finalAction = list(Constant.NormalWalkSideWayFast)

def processCommand(cmd):
    global wirelessCommand,walkCommand,bStop,numOfFrames
    wirelessCommand = None
    print "Odometry got ", cmd
    if cmd[:4] == "odom":
        if cmd[4:].strip() == "":
            bStop = True
        else:
            bStop = False
            walkCommand = map(float, cmd[4:].split())
            if len(walkCommand) == 4:
                numOfFrames = int(walkCommand[-1])
                walkCommand = walkCommand[:-1]
            else:
                numOfFrames = 10000
            print "got walk command ", walkCommand , type(walkCommand)
            resetEverything()
    elif cmd == "sloc":
        wirelessCommand = HelpTrack.stationaryLocalise

