#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: Offline.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




"""
    Offline testing.
"""

import math
import Constant
import HelpShort

def main():
#(133.47570374338622, 21.750494980945284)
    isBallDistanceTooFarInversly(133.48, 21.75)

def isBallDistanceTooFarInversly(selfX, selfY):
    goalieDistanceFromHome = HelpShort.getDistanceBetween(selfX, \
            selfY, Constant.FIELD_WIDTH / 2, 0)
    
##~     if not see ball trace
##~     if see ball but >= 75 return false

    alpha = 500.0
    print "Distance: ", goalieDistanceFromHome
    requiredBallDist = alpha / goalieDistanceFromHome
    
                       
    print requiredBallDist

# Return a tuple of (x, y, h) for search defend case.
def calculateSearchDefendPositionHeading():
    pivotX = Constant.FIELD_WIDTH / 2.0
    pivotY = Constant.WALL_THICKNESS
    pivotMajorAxis = 35.0
    pivotMinorAxis = 5.0

    # Assume the robot is facing toward the field, like 90 degrees in global.
    selfX = Constant.FIELD_WIDTH / 2.0
    selfY = Constant.WALL_THICKNESS
    selfH = 90
 
    ballX     = selfX + 20
    ballY     = selfY - 20

    # Both ballX and ballY are global.
    diffX = ballX - selfX
    diffY = ballY - selfY
    ballH = HelpShort.normalizeAngle_180(HelpShort.RAD2DEG(math.atan2(diffY, diffX)) - selfH)
    
    defendPos = [-1, -1, -1]
    
    # Find intercept between line through ball and pivot point and ellipse
    # centred at pivot point and of the pivot axis.
    # Perform translation to make pivot point (0, 0)
    relX = ballX - pivotX
    relY = ballY - pivotY
    
    # Perform scaling to convert ellipse into unit circle.
    scaleX = relX / pivotMajorAxis
    scaleY = relY / pivotMinorAxis
    
    # Find intersection of line (0,0) -> (x,y) and unit circle.
    scaleLength = math.sqrt(HelpShort.SQUARE(scaleX) + HelpShort.SQUARE(scaleY))
    intX        = scaleX / scaleLength
    intY        = scaleY / scaleLength
    
    # Here we assume bally >= pivoty.
    if intY < 0:
        print scaleY, scaleLength, relY, pivotMinorAxis, ballY, pivotY
##~         Debug.goAndMakeTraceBack()
        intY = 0
    
    intH = HelpShort.RAD2DEG(math.atan2(intY, intX))
    tanAngle = None
    
    if intX > 0:
        tanAngle = 90 - intH
    else:
        tanAngle = intH - 90

    # Reverse scaling.
    unscaleX = intX * pivotMajorAxis
    unscaleY = intY * pivotMinorAxis
    opposite = math.atan(HelpShort.DEG2RAD(tanAngle))
    opposite = opposite * (pivotMinorAxis / pivotMajorAxis)
    unscaleTanAngle = HelpShort.RAD2DEG(math.atan(opposite))
    
    if intX > 0:
        defendPos[2] = 90 - unscaleTanAngle
    else:
        defendPos[2] = 90 + unscaleTanAngle
        
    defendPos[2] = ballH
    
    # Reverse translation.
    defendPos[0] = unscaleX + pivotX
    defendPos[1] = unscaleY + pivotY
    
    return defendPos
