#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: OpenChallenger.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#
#TODO: need GetBehindBall <- need good GPS <- motion update <- odometer learner
#===============================================================================
#   Python Behaviours : 2004 (c) 
#
#   OpenChallenger.py
# 
# Keep away soccer player
# TODO:
#   
#   Test passing, role switching --> DONE
#   AttackerDog turns to the smart direction when lost the ball.
#   fix shouldPass near the edge --> don't pass to near tm or something like that
#   Turnkick hesteresis -> pawkick afterward  
#   SupportDog run to teammate it sees no opponent
#   Bug turning to wireless ball -> head doesn't move. should update wireless ball whenever it can
#   SupportDog should attack ball it teammate is far behind.
#   Give up ball if opponent is far away
#   Check PanicBallState and triggers
#   Get out of corner by passing far away the other side of the field
#   If opponent is behind -> don't turn
#   Active support dog -> run to free region if opponent is very far from teammate
#   
#   Head Soft command when moving counter-direction
#   
#
#   
#   
# 
#   
# 
#       
#       
# 
#===============================================================================

"""
Keep away soccer player
"""

import Global
import HelpShort
import LocateBall
import VisionLink
import Constant
import GetBehindBall
import HelpLong
import HelpTrack
import FWHead
import Debug
import ActiveLocalise
import HoverToBall
import HelpWhere
from StateBasedAction import StateBasedAction
import PawKick
import math


myTeammateNumber = 0

SUPPORTER = 1
ATTACKER = 2
myRole = 0

myBallDistance = 0
ballPos = (0.0,0.0)
localBallX = 0

myPos = (0.0,0.0)
myHeading = 0
ballToMe = 0

teammate = None
teammateToBall = 0.0
teammateBallD = 0.0
teammatePos = (145.0,340.0)
teammateHeading = 0
teammateBehaviours = None
teammateMeD = 0
teammateToMe = 0

opponentPos = (145,220)
opponentMeD = 0
opponentToMe = 0
lastOppSeenTime = -1
opponentBallD        = 0
opponentToBall = 0
oppTeammateD    = 0


DIR_STABLE_PERIOD = 60 #change teammate direction once every 100 frames
wirelessCommand = None
FP_ATTACK               = [3,2,0,0,0]
FP_GRABBED              = [3,2,1,2,3]
FP_PULLING_OFF_EDGE     = [3,1,0,0,0]
FP_KICK_AIMING          = [3,0,0,0,3]
FP_EDGE_BALL            = [3,0,0,0,0]
FP_BLOCKING_DOG         = [2,2,2,2,2]
FP_KEEP_AWAY            = [2,0,2,0,2]
FP_APPROACHING          = [2,0,0,0,2]
FP_HANDLE_EDGE_BALL     = [2,0,0,0,0]
FP_NORMAL_BALL_STATE    = [1,2,2,2,1]
FP_SMART_PASSING        = [1,2,0,2,1]
FP_SMART_BLOCKING       = [1,1,1,1,1]
FP_GRABBING             = [1,0,0,0,1]
FP_TURN_KICK            = [0,2,0,2,0]
FP_DRIBBLING_TO_TM      = [0,1,1,1,0]
FP_EXPECT_BALL_FROM_TM  = [0,1,0,1,0]
FP_PANIC_BALL_STATE     = [0,0,2,0,0]
FP_ACTIVE_LOC           = [0,0,1,0,0]
FP_SUPPORT              = [0,0,0,2,3] 
FP_WATCHING_OUT         = [0,0,0,2,2]
FP_GET_OUT_OF_STUCK     = [0,0,0,2,1]
FP_MY_PAW_KICK          = [0,0,0,2,0]
FP_SMART_SUPPORTER      = [0,0,0,1,3]
FP_RUN_AWAY             = [0,0,0,1,2]
FP_BLOCK_TURNING        = [0,0,0,1,1]
FP_HELP_TRACKING_BALL   = [0,0,0,1,0]
FP_TURNING_TO_TM_BALL   = [0,0,0,0,3]
FP_LOCATE_OPPONENT      = [0,0,0,0,2]
FP_SMART_APPROACHING    = [0,0,0,0,1]


bShowSkillLED = False
bNoDynamicRole = False
bDebugging = False
FixedTeammatePos = (145,130) #(100,100)
FixedOpponentPos = "behind" #(145,230)
FixedBallPos = None #(260,200)

#wireless messages
sendBallDist    = 0     # ball dist
isStriker       = False #
isGoalie        = False # 
haveBall        = False # attacker
kickedOff       = False # just kicked
isDefending     = False 
isBackOff       = False # supporter
        

# Stuck detection. 1 second = 30 frames.
STUCK_NUMBER_OF_FRAMES = 30
STUCK_PWM = 1
STUCK_VPULL = 2
lastMaxPWMValues = [0] * STUCK_NUMBER_OF_FRAMES
stuckDetected = False

grabBallCounter = 0

def setRole(role):
    global myRole
    myRole = role
    
        
def RandomKick():
    if Global.frame % 2 == 0:
        return Constant.HandKickLeftWT
    else:
        return Constant.HandKickRightWT
        
FancyKick = None
def initPlayer():
    print "Init player"
    
    global myTeammateNumber,FancyKick
    if Global.myPlayerNum == 1:
        myTeammateNumber = 2
        setRole(ATTACKER)
        FancyKick = Constant.FwdKickWT
    else:
        myTeammateNumber = 1
        setRole(SUPPORTER)
        FancyKick = RandomKick()


def setDebuggingValue():
    global teammatePos,opponentPos,ballPos
    if FixedTeammatePos is not None:
        teammatePos = FixedTeammatePos
    
    if FixedOpponentPos == "behind":        
        opponentPos = HelpShort.getPointRelative(*(myPos + (myHeading,-20)))
    elif FixedOpponentPos is not None:
        opponentPos = FixedOpponentPos
    if FixedBallPos is not None:
        ballPos = FixedBallPos
    
def resetEachFrame():
    global myBallDistance,ballPos,localBallX, \
        myPos, myHeading, ballToMe, \
        teammate,teammatePos,teammateBehaviours,teammateToBall,\
            teammateMeD,teammateHeading, teammateBallD, \
        opponentPos,opponentToMe,lastOppSeenTime,oppBallD, \
            opponentMeD,opponentToBall,oppTeammateD,opponentBallD,\
        grabBallCounter
        
    Debug.showDebug("Frame %d " % Global.frame)
    #original
    ballPos = (Global.ballX,Global.ballY)
    
    myBallDistance = Global.vBall.getVobDistance()
    myHeading = Global.selfLoc.getHeading()
    myPos = Global.selfLoc.getPos()
    
    teammate = Global.teammatesLoc[myTeammateNumber - 1]
    teammatePos = Global.teammatesLoc[myTeammateNumber - 1].getPos()
    teammateHeading = Global.teammatesLoc[myTeammateNumber - 1].getHeading()
    teammateBehaviours = Global.teamPlayers[myTeammateNumber - 1]    
    opponentPos = Global.Vector(*VisionLink.getGPSOpponentInfo(0,Constant.CTGlobal)).getPos()
    for vobDog in Global.vOpponents:
        if vobDog.getConfidence() > 0:
            lastOppSeenTime = Global.frame
            
    if bDebugging:
        setDebuggingValue()
        
    
    #derived
    localBallX = Global.vBall.getVobDistance() * \
            math.sin(HelpShort.DEG2RAD(-Global.vBall.getHeading()))
    ballToMe = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(myPos+ballPos)) )
    if Global.frame % DIR_STABLE_PERIOD == 0:
        teammateToBall = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(ballPos + teammatePos)) )
##~         print "dir = " , teammateToBall
    teammateMeD = HelpShort.getDistanceBetween(*(myPos + teammatePos))
    teammateBallD = HelpShort.getDistanceBetween(*(teammatePos + ballPos))
    
    opponentMeD = HelpShort.getDistanceBetween(*(myPos + opponentPos))
    opponentToMe = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(myPos + opponentPos)) )

    opponentBallD = HelpShort.getDistanceBetween(*(opponentPos+ballPos))
    opponentToBall = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(ballPos + opponentPos)) )
##~     Debug.showDebug("opponentToBall %s" % str( (opponentToBall, ballPos , opponentPos)) )
    oppTeammateD  = HelpShort.getDistanceBetween(*(teammatePos+ opponentPos))

    
    #wireless message bit
    global sendBallDist, isStriker, isGoalie, haveBall, kickedOff, isDefending, isBackOff
    if globalState.isHoldingBall():
        sendBallDist = 1 #very close value
    elif Global.lostBall == 0:
        sendBallDist = Global.ballD
    else:
        sendBallDist = 0
    isStriker = False
    isGoalie = False
    haveBall = False
    kickedOff = False
    isDefending = False
    isBackOff = False

    #
    if Global.lostBall == 0 and Global.ballD < 13.5 \
        and abs(localBallX) < 3:
        #and abs(localBallX) + Global.ballD <= 14:
        grabBallCounter += 1
    else:
        grabBallCounter = 0
        
def setMessageBits(myNumber = None, isHoldingBall = None, blah2=None, \
        iamAttacker=None, justKicked = None, blah3 = None, iamSupporter = None):
    global sendBallDist, isStriker, isGoalie, haveBall, kickedOff, isDefending, isBackOff
    if myNumber is not None:
        sendBallDist = myNumber
    if isHoldingBall is not None:
        isStriker = isHoldingBall
    if blah2 is not None:
        isGoalie = blah2
    if iamAttacker is not None:
        haveBall = iamAttacker
    if justKicked is not None:
        kickedOff = justKicked
    if blah3 is not None:
        isDefending = blah3
    if iamSupporter is not None:
        isBackOff = iamSupporter
    
def teammateSeeingBall():
    return teammateBehaviours.getBallDist() > 0
    
def notImplementedYet(msg = ""):
    print "State not implemented yet :",msg
    
############################################################
## Smart decisions 

passingPoints = [ (60,60) , (230,60) , (60,380), ( 230, 380) , 
                (145, 220) , #center
                (0,220), (280, 220) ]
SAFETY_DIFFERENCE   = 60 #if teammate is 60 cm closer, then it's safe
TOO_CLOSE_TO_PASS   = 50
TOO_CLOSE_TO_TEAMMATE = 50

def goodPointToPass(x,y):
    pointMeOpp = HelpShort.angleBetweenTwoPointsFromPivotPoint(*( (x,y)+ opponentPos + myPos))
    if abs(pointMeOpp) < SAFETY_ANGLE:
        return False
    else:
        dBall = HelpShort.getDistanceBetween(*( (x,y) + ballPos))
        dOpp = HelpShort.getDistanceBetween(*( (x,y) + opponentPos))
        dTM = HelpShort.getDistanceBetween(*( (x,y) + teammatePos))
        dMe = HelpShort.getDistanceBetween(*( (x,y) + myPos))
        return dOpp - dTM > SAFETY_DIFFERENCE and dBall > TOO_CLOSE_TO_PASS \
            and dTM < dMe
            
OPPONENT_IS_PRETTY_CLOSE = 50
def canSafelyPassToTeammate():
    if teammateMeD < TOO_CLOSE_TO_TEAMMATE or opponentMeD < OPPONENT_IS_PRETTY_CLOSE:
        return False
    for (x,y) in passingPoints:
        if goodPointToPass(x,y):
            return (x,y) #can be used as True
    return False

def getSafePositionToPassToTeammate():
    for (x,y) in passingPoints:
        if goodPointToPass(x,y):
            return (x,y) #can be used as True
    return (0,0) 
    
def isBallInDanger():
    if not globalState.isHoldingBall():
        return opponentMeD < 60 or opponentBallD < 60  
    else:
        return opponentMeD < 60

###########################################################
## Smart positions

def isInTopBottomEdge(_,y, offset = 60):
    return y < offset or y > Constant.FIELD_LENGTH - offset
    
def isInLeftRightEdge(x,_, offset = 60):
    return x < offset or x > Constant.FIELD_WIDTH - offset
    
###########################################################


class GlobalState:
    def __init__(self):
        self.bHoldingBall = False
    
    def setHoldingBall(self,b = True):
        self.bHoldingBall = b
    
    def isHoldingBall(self):
        return self.bHoldingBall
    
globalState = GlobalState()

bNoActiveLocalise = False
class MyActiveLocalise(StateBasedAction):
    ACTIVE_LOCALISE_INTERVAL = 60
    DOING_ACTIVE_LOCALISE = 10
    CLOSE_DISTANCE = 40
    CLOSE_DISTANCE_SLOW_BALL = 40 #20
    
    def __init__(self):
        StateBasedAction.__init__(self)
        self.activeLocaliseCounter = self.ACTIVE_LOCALISE_INTERVAL
        
    def setNoActiveLocalise(self):
        #kinda hack, to tell this state and every instance of this state
        #not to active localise
        global bNoActiveLocalise
        bNoActiveLocalise = True
        
    def setActiveLocalise(self):
        global bNoActiveLocalise
        bNoActiveLocalise = False
        
    def finishAction(self): #do reseting counter
        self.activeLocaliseCounter = self.ACTIVE_LOCALISE_INTERVAL
        
    def DoAction(self):
        if (Global.lostBall < 5):
            HelpTrack.trackVisualBall()
        elif Global.lostBall <= 10:
            HelpLong.setHeadParams(0,-20,-20,Constant.HTAbs_h)
        elif (Global.lostBall <= 30
                and abs(Global.gpsLocalBall.getHeading()) < 90): 
            HelpTrack.trackGpsBall()
        else:
            HelpTrack.stationaryLocalise()
                
        #decreasing counter
        self.activeLocaliseCounter -= 1
        if self.activeLocaliseCounter < - self.DOING_ACTIVE_LOCALISE:
            return None #stop action, finishAction called()
        elif self.activeLocaliseCounter < 0:
            #no active localising cases
            if bNoActiveLocalise:
                self.setActiveLocalise()
                return self
            #ball too close, should not active localise
            if Global.lostBall == 0:
                
                if Global.ballD < MyActiveLocalise.CLOSE_DISTANCE_SLOW_BALL:
                    return self 
##~                 #hack: magic number: if ball velocity is not very small (not still)
##~                 if VisionLink.getGPSBallVInfo(1)[2] > 0.05 \
##~                     and Global.ballD < MyActiveLocalise.CLOSE_DISTANCE:
##~                     return self
            if bShowSkillLED:
                HelpLong.showFacePattern(FP_ACTIVE_LOC)
            ActiveLocalise.SmartSetBeacon(90,500)
            ActiveLocalise.DecideNextAction(False)
            
        return self
     
class MyHoverToBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        headAction = Global.finalAction[Constant.AAHeadType:]
        indicator = Global.finalIndicators[:] #save indicators
        HoverToBall.DecideNextAction()
        Global.finalIndicators = indicator
        Global.finalAction[Constant.AAHeadType:] = headAction
        
        return self

        
NO_KICK_PERIOD = 27 #only 30?
class KickBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.kickCounter = 0
        self.seenBall = False
        
    def beginAction(self):
        self.kickCounter = 0
        self.seenBall = False
    
    def DoAction(self):
##~         kickAngle = HelpShort.normalizeAngle_180(teammateToBall - myHeading)
##~         print "Kicked", kickAngle
        
        Global.finalAction[Constant.AAWalktype] = RandomKick()
        HelpLong.setForceStepComplete()
        return self.outState
##~         self.kickCounter = int(float(self.counter) / NO_KICK_PERIOD)
##~         if Global.lostBall == 0:
##~             self.seenBall = True
##~             if kickAngle < -30:
##~                 Global.finalAction[Constant.AAWalktype] = Constant.UpennLeftWT
##~             elif kickAngle > 30:
##~                 Global.finalAction[Constant.AAWalktype] = Constant.RightWT
##~             else:
##~ 
##~         if self.seenBall or self.kickCounter >= 2:
##~             return self.outState
##~         else:
##~             return self
                    
class MyLocateBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        if Global.lostBall == 0:
            return self.outState
        else:
            LocateBall.DecideNextAction()
            FWHead.DecideNextAction()
            return self

def isStillHead(tolerance = 2):
    return abs(Global.desiredPan - Global.degPan) < tolerance and \
        abs(Global.desiredTilt - Global.degTilt) < tolerance and \
        abs(Global.desiredCrane - Global.degCrane) < tolerance
        
class PanningHead(StateBasedAction):
    STARING_TIME = 5

    def __init__(self):
        StateBasedAction.__init__(self)
        self.panningDir = Constant.dCLOCKWISE
        self.right, self.left = 0,0
        self.alcounter = 0
        
    def setRange(self,right,left):
        self.right, self.left = right,left
        
    def DoAction(self):
        if self.panningDir == Constant.dCLOCKWISE:
            if isStillHead(10):
                self.alcounter += 1
                if self.alcounter == PanningHead.STARING_TIME:
                    self.panningDir = Constant.dANTICLOCKWISE
                    self.alcounter = 0
            HelpLong.setHeadParams(*self.right )
        else:
            if isStillHead(10):
                self.alcounter += 1
                if self.alcounter == PanningHead.STARING_TIME:
                    self.panningDir = Constant.dCLOCKWISE
                    self.alcounter = 0        
            HelpLong.setHeadParams(*self.left)
        return self
  
TOO_SHORT_PERIOD = 15
class KickTurning(StateBasedAction):
    TURNING_LEFT_720 = 7.2
    TURNING_RIGHT_720 = 7.2
    CAN_CHECK_CHIN_TIME = 18
    def __init__(self):
        StateBasedAction.__init__(self)
        self.desiredHeading = 0
        self.turningTime = 0
        self.walkParams = None
        self.turnDir = None
        
    def calculateDesiredHeading(self):
        self.desiredHeading = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(myPos + teammatePos)))
##~         print "My Pos = ",myPos
##~         print "desiredHeading=",self.desiredHeading

        
    def calculateTurningTime(self):
        turnNeeded = HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)
        print "Turn needed = ",turnNeeded," my H = ", myHeading

        if turnNeeded > 0:
            calibrate = self.TURNING_LEFT_720
            self.walkParams = list(Constant.TurnHoldingCounterClockWise)
            self.turnDir = Constant.dANTICLOCKWISE
        else:
            calibrate = self.TURNING_RIGHT_720
            self.walkParams = list(Constant.TurnHoldingClockWise)
            self.turnDir = Constant.dCLOCKWISE
            
        if turnNeeded == 0:
            self.turningTime = 0
        else:
            self.turningTime = calibrate * 30 / (720.0/abs(turnNeeded))
        print "Turning time = ",self.turningTime
        
    def beginAction(self):
        self.calculateDesiredHeading()
        self.calculateTurningTime()
        HelpLong.openMouth(GRABBING_MOUTH_OPEN)
        
    def finishAction(self):
        HelpLong.openMouth(Constant.IND_MOUTH_CLOSED)
        
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_KICK_AIMING)
        Global.finalAction = self.walkParams[:]
        Global.forceHighGain = True
##~         print "Turning "
        if self.counter >= self.CAN_CHECK_CHIN_TIME and \
            VisionLink.getAnySensor(Constant.ssMOUTH) - GRABBING_MOUTH_OPEN < MyGrabBall.STUCK_THRESHOLD:
                return None
                
        if self.counter >= self.turningTime:
            return self.outState
        else:
            return self
     
#turn to a specified position
class KickTurningToPosition(KickTurning):
    def __init__(self):
        KickTurning.__init__(self)
        self.position = (0,0)
        
    def setPosition(self,pos):
        self.position = pos

    def calculateDesiredHeading(self):
        self.desiredHeading = HelpShort.normalizeAngle_0_360(HelpShort.getHeadingBetween(*(myPos + self.position)))
        
        
def setBackWalkSitDown():
    Global.finalAction[Constant.AACmd:Constant.AAHeadType] = list (Constant.BackWalkSitDownHoldingBall[Constant.AACmd:Constant.AAHeadType])
    
#turning customized for NormalBallState
SAFETY_ANGLE = 45
MINIMUM_KICK_TURNING_ANGLE = 50 #for kick turning, it needs at least 50 deg turn to be effective

class NormalKickTurning(KickTurning):
    def __init__(self):
        KickTurning.__init__(self)
        
    def calculateDesiredHeading(self):
        oppMeTM = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + teammatePos + myPos))
        print "myPos = ",myPos, " oppPos = " , opponentPos, " tm Pos = " , teammatePos
        print "oppMeTM = ", oppMeTM, "opponentToMe = ", opponentToMe
        if abs(oppMeTM) > SAFETY_ANGLE:
            self.desiredHeading = HelpShort.getHeadingBetween(*(myPos + teammatePos)) 
        else:   
            if oppMeTM > 0:
                self.desiredHeading = HelpShort.normalizeAngle_0_360(opponentToMe + SAFETY_ANGLE)
            else:
                self.desiredHeading = HelpShort.normalizeAngle_0_360(opponentToMe - SAFETY_ANGLE)
                
        turnCCW = HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)
        print "turnCCW = ",turnCCW, " my heading = ", myHeading
        if abs(turnCCW) < MINIMUM_KICK_TURNING_ANGLE:
            if turnCCW * oppMeTM > 0:
                turnCCW = HelpShort.extendToLimit(turnCCW,MINIMUM_KICK_TURNING_ANGLE)
            else:
                turnCCW = 0
            print "adjusted = " , turnCCW
        
        self.desiredHeading = HelpShort.normalizeAngle_0_360(myHeading + turnCCW)
        print "desiredHeading = " , self.desiredHeading
    
#fixed bug where ActiveLocalise doesn't look at any beacon
class BallHoldingLocalise(StateBasedAction):
    HEAD_DOWN_TIME  = 10
    OPPONENT_COMING_CLOSE  = 90
    SIT_DOWN_PRELUDE = 10
    NOT_SEEN_BEACON_FOR_LONG = 60
    
    def __init__(self):
        StateBasedAction.__init__(self)
        self.headDownCounter = 0
        self.lastBeaconSeenTime = 0
        
    def setMoveOn(self): #force to move to next state
        self.headDownCounter = 1
        
    def notSeenBeaconForALongTime(self):
        for i in range(Constant.vobBlueLeftBeacon, Constant.vobYellowRightBeacon+1):
            if VisionLink.getVisualObject(i)[0] > 0:
                self.lastBeaconSeenTime = Global.frame
        return Global.frame - self.lastBeaconSeenTime > self.NOT_SEEN_BEACON_FOR_LONG
        
    def DoAction(self):
        if Global.selfLoc.getPosVar() > HelpShort.get95cf(100) or self.notSeenBeaconForALongTime():
            HelpTrack.stationaryLocalise()
        else:
            ActiveLocalise.SmartSetBeacon(90,500)
            ActiveLocalise.DecideNextAction(False)
            
        if self.counter < self.SIT_DOWN_PRELUDE:
            HelpLong.setNormalWalk(0,0,0)
            HelpLong.setHeadParams(0,-70,50,Constant.HTAbs_h)
            HelpLong.setForceStepComplete()
            #Hack stance (from MyGrabBall)
            Global.finalAction[Constant.AAHf] = 70
            Global.finalAction[Constant.AAHb] = 100
            Global.finalAction[Constant.AAFfo] = 95
            Global.finalAction[Constant.AAFso] = 5
        else:
            setBackWalkSitDown()
            #TOBE TESTED
            setMessageBits(isHoldingBall = True)
            
        if self.headDownCounter == 0 and opponentMeD < self.OPPONENT_COMING_CLOSE :
            self.headDownCounter = 1
        
        if Global.lostBall == 0 and Global.ballD > 20:
            return None #weird, i'm supposed to hold the ball
        elif self.headDownCounter > 0:
            Global.forceHighGain = True #prepare to kick, TODO: find out why dynamic gain for kick doesn't work
            HelpLong.setHeadParams(0,-60,50,Constant.HTAbs_h)
            if self.headDownCounter >= self.HEAD_DOWN_TIME:
                return self.outState
            else:
                self.headDownCounter += 1
                return self
        else:            
            return self
        
    def beginAction(self):
        globalState.setHoldingBall()
        self.headDownCounter = 0
        self.lastBeaconSeenTime = Global.frame
        
    def finishAction(self):
        globalState.setHoldingBall(False)
        
    def isNotInDanger(self):
        return self.headDownCounter == 0 and self.counter > self.SIT_DOWN_PRELUDE + 60

GRAB_BALL_TOO_LONG = 60
LOST_BALL_GRABBING_TOO_LONG = 60
BALL_TWO_FAR = 20
LOST_BALL_GRABBING_ENOUGH = 10
SEE_BALL_TOO_MUCH = 30
UNDER_CHIN_BALL_DISTANCE = 10
GRABBING_MOUTH_OPEN         = -750000

class MyGrabBall(StateBasedAction):
##~     OPEN_MOUTH_TIME = 10 #time wait for the mouth to push the ball inside
    CAN_CHECK_CHIN_TIME = 18 #time wait to check the sensor CAN_CHECK_CHIN_TIME - OPEN_MOUTH_TIME = time taken the mouth to open
    STUCK_THRESHOLD = 10000
    SHOULD_NOT_SEE_BALL = 10
    MOVING_HEAD_FORWARD = 5
    def __init__(self,crane = 50):
        StateBasedAction.__init__(self)
        self.bBallUnderChin = False
        self.crane = crane
        
    def beginAction(self):
        self.bBallUnderChin = False
        self.firstHaveBall = Global.haveBall
        self.lastLostBall = Global.lostBall
        
    def finishAction(self):
        self.bBallUnderChin = False
        HelpLong.openMouth(Constant.IND_MOUTH_CLOSED)
        
    def DoAction(self):
        if bShowSkillLED:
            HelpLong.showFacePattern(FP_GRABBING)
        if Global.lostBall - self.lastLostBall > LOST_BALL_GRABBING_TOO_LONG:
            self.setExitGate("LOST_BALL_GRABBING_TOO_LONG")
            return None
            
        if (Global.lostBall == 0 and Global.ballD > BALL_TWO_FAR):
            self.setExitGate("BALL_TWO_FAR")
            return None
##~         #otherwise, if cannot see ball, then it is good
##~         if Global.lostBall > LOST_BALL_GRABBING_ENOUGH:
##~             HelpLong.showFacePattern(FP_GRABBED)
##~             self.bBallUnderChin = True
##~             return self.outState
            
        if self.counter > MyGrabBall.SHOULD_NOT_SEE_BALL and Global.lostBall == 0:
            self.setExitGate("See ball while shouldn't")
            return None
            
        if self.bBallUnderChin and Global.lostBall == 0:
            self.setExitGate("False BallUnderChin")
            return None
        #when grabbingBall it should not see ball, except when the head is stuck 
        #on top of the ball
        if Global.haveBall - self.firstHaveBall > SEE_BALL_TOO_MUCH and \
            Global.ballD > UNDER_CHIN_BALL_DISTANCE:
            self.setExitGate("SEE_BALL_TOO_MUCH")
            return None
            
        #check touch sensors
        if VisionLink.getAnySensor(Constant.ssCHIN) > 0:
            print "Chin pressed"
            return self.outState
            
        #check chin sensors
        if self.counter > MyGrabBall.CAN_CHECK_CHIN_TIME :
            if VisionLink.getAnySensor(Constant.ssMOUTH) - GRABBING_MOUTH_OPEN > MyGrabBall.STUCK_THRESHOLD:
                print "mouth sensor"
                return self.outState
            else:
                return None 
                
        
        HelpLong.setNormalWalk(0,0,0)
        #move head toward the ball 
        if self.counter < self.MOVING_HEAD_FORWARD:
            HelpLong.setHeadParams(0,-60,50,Constant.HTAbs_h)
        else:
            HelpLong.openMouth(GRABBING_MOUTH_OPEN)
            HelpLong.setHeadParams(0,-75,self.crane,Constant.HTAbs_h)
            
        #Hack stance
        if self.counter > self.MOVING_HEAD_FORWARD + 5:
            Global.finalAction[Constant.AAHf] = 70
            Global.finalAction[Constant.AAHb] = 100
            Global.finalAction[Constant.AAFfo] = 90
            Global.finalAction[Constant.AAFso] = 5
        
        
##~         if self.counter > MyGrabBall.OPEN_MOUTH_TIME:
##~         HelpLong.openMouth(GRABBING_MOUTH_OPEN)
        return self
        
    def isBallUnderChin(self):
        return self.bBallUnderChin
    
    def shouldGrabTheBall(self):
        return Global.lostBall == 0 and \
                grabBallCounter >= 5 #to ensure the ball is not moving
                
STOP_POINT = 10.0
SLOW_DOWN_POINT = 25.0
MAX_FORWARD_SPEED = 6.0
MIN_FORWARD_SPEED = 3.0
MAX_SLOW_WALK_TURNCCW = 30

def setNormalSlowWalk (forward, left, turnCCW):
    Global.finalAction[Constant.AAWalktype:Constant.AAHeadType] = list (Constant.NormalWalkSlow[Constant.AAWalktype:Constant.AAHeadType])
    HelpLong.setForwardLeftTurn(forward,left,turnCCW)
    
class ApproachingBall(StateBasedAction):
    def __init__(self,mySTOP_POINT = STOP_POINT,mySLOW_DOWN_POINT = SLOW_DOWN_POINT):
        StateBasedAction.__init__(self)
        self.mySLOW_DOWN_POINT = mySLOW_DOWN_POINT
        self.mySTOP_POINT = mySTOP_POINT
        
    def DoAction(self):
        if bShowSkillLED:
            HelpLong.showFacePattern(FP_APPROACHING)
        if Global.lostBall > 0:
            return None #cannot see the ball, exit
        if Global.ballD <= self.mySTOP_POINT:
            return self.outState #successful, goto next state
        if Global.ballD > self.mySLOW_DOWN_POINT:
            return None #none of by business, exit state
        else:
            tmp = (self.mySLOW_DOWN_POINT - self.mySTOP_POINT) #avoid pychecker warning
            forward = (Global.ballD - self.mySTOP_POINT)/tmp * (MAX_FORWARD_SPEED - MIN_FORWARD_SPEED) + MIN_FORWARD_SPEED
            if abs(Global.ballH) > MAX_SLOW_WALK_TURNCCW:
                forward = 0
            setNormalSlowWalk( forward ,0, HelpShort.CLIP(Global.ballH/3,MAX_SLOW_WALK_TURNCCW))
            
##~             print "setNormalSlowWalk ",forward, HelpShort.CLIP(Global.ballH,30)
##~             print "forward = ",forward,Global.ballD, Global.finalAction[Constant.AAHb]
            HelpLong.setForceStepComplete()
    
            return self
        
class MyGetBehindBall(StateBasedAction):
    LOST_BALL_TOO_MUCH = 30
    def __init__(self):
        StateBasedAction.__init__(self)
        self.radius = 0
        self.heading = 0
        
    def setParameters(self,radius, heading):
        self.radius , self.heading = radius, heading
        
    def DoAction(self):
        GetBehindBall.getBehindBall(self.radius, self.heading, Constant.dAUTO, False)
        if Global.lostBall > self.LOST_BALL_TOO_MUCH:
            return None
        return self

class GetBehindBallTowardTeammate(MyGetBehindBall):
    def __init__(self,radius):
        MyGetBehindBall.__init__(self)
        self.radius = radius
        
    def DoAction(self):
        self.setParameters(self.radius,teammateToBall)
        return MyGetBehindBall.DoAction(self)
        
class GetBehindBallBlockingBall(MyGetBehindBall):
    def __init__(self,radius):
        MyGetBehindBall.__init__(self)
        self.radius = radius
        
    def DoAction(self):
        ballToOppDir = HelpShort.normalizeAngle_0_360(opponentToBall + 180)
        self.setParameters(self.radius,ballToOppDir)
        return MyGetBehindBall.DoAction(self)
        
class MyPawKick(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.whichPaw = PawKick.FIRE_PAWKICK_AUTO
        
    def setPaw(self,paw):
        self.whichPaw = paw
            
    def setPawKickNearEdge(self):
        if HelpWhere.edgeIsOnMyRight(myPos[0],myPos[1],myHeading):
            self.setPaw(PawKick.FIRE_PAWKICK_RIGHT)
        else:
            self.setPaw(PawKick.FIRE_PAWKICK_LEFT)
            
    def DoAction(self):
        if bShowSkillLED:
            HelpLong.showFacePattern(FP_MY_PAW_KICK)
        if Global.lostBall == 0:
            lastInd = Global.finalIndicators[:]
            PawKick.firePawKick(self.whichPaw)
            Global.finalIndicators = lastInd[:]
            return self
        else:
            return None
        
    def shouldBeActivated(self):
        if Global.ballSource != Constant.VISION_BALL:
            return False
        isBallOnEdge = not HelpWhere.ballNotAlongEdge()

        if isBallOnEdge:
            if HelpWhere.isOnLEdge() :
                if HelpWhere.isInRange(0,180):
                    self.whichPaw = PawKick.FIRE_PAWKICK_LEFT
                    return True
                else:
                    self.whichPaw = PawKick.FIRE_PAWKICK_RIGHT
                    return True
            elif HelpWhere.isOnREdge() :
                if HelpWhere.isInRange(0,180):
                    self.whichPaw = PawKick.FIRE_PAWKICK_RIGHT
                    return True
                else:
                    self.whichPaw = PawKick.FIRE_PAWKICK_LEFT
                    return True
            elif HelpWhere.isOnTEdge():
                if HelpWhere.isInRange(90,270):
                    self.whichPaw = PawKick.FIRE_PAWKICK_RIGHT
                    return True
                else:
                    self.whichPaw = PawKick.FIRE_PAWKICK_LEFT
                    return True
            elif HelpWhere.isOnBEdge():
                if HelpWhere.isInRange(90,270):
                    self.whichPaw = PawKick.FIRE_PAWKICK_LEFT
                    return True
                else:
                    self.whichPaw = PawKick.FIRE_PAWKICK_RIGHT
                    return True
        return False
        
def resolveStuckDetected():
    (maxPWM,whichLeg) = HelpLong.getStuckInfo()
    if maxPWM > 400: #got stuck
        correctionVector = (0,0)
        if whichLeg in [Constant.legFRONT_RIGHT,Constant.legBACK_RIGHT]:
            correctionVector = (0,5) #forward,left
        else:
            correctionVector = (0,-5) #forward,left
        forward = Global.finalAction[Constant.AAForward]
        left = Global.finalAction[Constant.AALeft]
        print "stuck ",whichLeg,
        print " Old f,l = ",forward,left,
        oldLength = HelpShort.getLength([forward,left])
        forward += correctionVector[0]
        left += correctionVector[1]
        forward,left = HelpShort.normalise([forward,left])
        forward *= oldLength
        left *= oldLength
        print " New f,l = ",forward,left
        
KICKED_BALL_DISTANCE = 100
class NormalBallState(StateBasedAction):
    """
    Opponent is far away, have time to adjust angle..
    """
    APPROACHING_DISTANCE = 30
    ALLIGNED_ANGLE = 30
    def __init__(self):
        StateBasedAction.__init__(self)
##~         self.doKickAiming = KickAiming()
        self.debug = False 

        self.doGetBehindBall = GetBehindBallTowardTeammate(25)
        self.doApproaching = ApproachingBall(10,NormalBallState.APPROACHING_DISTANCE)
        self.doGrabBall = MyGrabBall()
        self.kickTurning = NormalKickTurning()
        self.ballHoldingLocalise = BallHoldingLocalise()
        self.kickBall = KickBall()

        self.doGetBehindBall.setOutState(self.doApproaching)
        self.doApproaching.setOutState(self.doGrabBall)
        self.doGrabBall.setOutState(self.kickTurning)
        self.kickTurning.setOutState(self.ballHoldingLocalise)
        self.ballHoldingLocalise.setOutState(self.kickBall)
        
    def safeToPassAHead(self):
        expectedBall = HelpShort.getPointRelative(*(myPos + (myHeading,KICKED_BALL_DISTANCE)))
        ballMeTM = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(expectedBall + teammatePos + myPos))
        oppMeTM = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + teammatePos + myPos))
        if ballMeTM * oppMeTM < 0 and \
            HelpShort.getDistanceBetween(*(expectedBall + teammatePos) ) < \
            HelpShort.getDistanceBetween(*(expectedBall + opponentPos) ):
            #if opp is far, be careful about the ball rolling toward him
            if opponentMeD > 200:
                return abs(oppMeTM) > 45
            else:
                return True
        return False
            
    def veryGoodTimeToPass(self):
        if opponentBallD > 200 :
            oppMeTM = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + teammatePos + myPos))   
            offset = HelpShort.extendToLimit(oppMeTM,SAFETY_ANGLE)
            desiredHeading = opponentToMe + offset
            if HelpShort.distanceToEdge(*(myPos + (desiredHeading,))) > 100:
                expectedBall = HelpShort.getPointRelative(*(myPos + (desiredHeading, KICKED_BALL_DISTANCE)))
                if HelpShort.getDistanceBetween(*(expectedBall + opponentPos)) - HelpShort.getDistanceBetween(*(expectedBall + teammatePos)) > 30:
                    return True
                else:
                    return False
            else:
                return False
        else:
            return False
        
    def notAlignedWithTeammate(self):
        self.desiredHeading = HelpShort.getHeadingBetween(*(myPos + teammatePos))
        return abs(HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)) > self.ALLIGNED_ANGLE
        
    #example of hybrid parent state. 
    #Make decision when appropriate and leave the child do the rest
    def DoAction(self):
        HelpLong.showFacePattern(FP_NORMAL_BALL_STATE)
        if self.subState is None: #active parent case
            if Global.lostBall == 0:
                self.doSubState(self.doGetBehindBall)
                return self
            else:
                return None
        else: #passive parent case
            #however, make still some decision here.
            if self.subState == self.ballHoldingLocalise and \
                self.veryGoodTimeToPass():
                self.ballHoldingLocalise.setMoveOn()
                
            if self.subState == self.ballHoldingLocalise and \
                self.safeToPassAHead():
                self.doSubState(self.kickBall)
            elif self.subState == self.ballHoldingLocalise and \
                self.ballHoldingLocalise.isNotInDanger() and \
                self.notAlignedWithTeammate():#dynamic state switching
                print "hehe, aligning"
                self.ballHoldingLocalise.setOutState(self.kickTurning)
                self.ballHoldingLocalise.setMoveOn()
                self.doSubState()
            elif self.subState == self.doGetBehindBall and \
                Global.lostBall == 0 and \
                Global.ballD < NormalBallState.APPROACHING_DISTANCE:
                if self.debug: print "do ApproachingBall"
                self.doSubState(self.doApproaching)
                
            elif self.subState == self.doApproaching and \
                self.doGrabBall.shouldGrabTheBall():
                if self.debug: print "GrabBall"
                self.doSubState(self.doGrabBall)
                
            else:
                #let the child do the rest
                self.doSubState()
                
                #dynamic state switching (cont..)
                if self.subState == self.kickTurning:
##~                     print "reconnect"
                    self.ballHoldingLocalise.setOutState(self.kickBall)
            return self
    

def setNormalWalkTurnKick(dir):
    if dir == Constant.dCLOCKWISE:
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = Constant.TurnKickClockWise[Constant.AACmd:Constant.AAHeadType]
    else:
        Global.finalAction[Constant.AACmd:Constant.AAHeadType] = Constant.TurnKickCounterClockWise[Constant.AACmd:Constant.AAHeadType]
        
class TurnKick(StateBasedAction):
    TURN_KICK_TIME = 30
    def __init__(self):
        StateBasedAction.__init__(self)
        self.turnDir = 0
        self.lastTurnSet = -1
        
    def beginAction(self):
        self.lastTurnSet = Global.frame
        
    def setTurnDir(self,dir = Constant.dCLOCKWISE):
        if Global.frame - self.lastTurnSet > 5:
            self.turnDir = dir
            self.lastTurnSet = Global.frame
        
    def DoAction(self):
        if bShowSkillLED:
            HelpLong.showFacePattern(FP_TURN_KICK)
        if Global.lostBall == 0 or self.counter < 5:
            if Global.lostBall == 0 and Global.ballD > 20:
                return None
            if self.counter < self.TURN_KICK_TIME:
                setNormalWalkTurnKick(self.turnDir)
                if self.counter == 0:
                    HelpLong.setForceStepComplete()
                return self
            else:
                return None
        else:
            return None
            
UP_OFFSET = 20
UP_KICK_ANGLE = 30
class PullBallOffEdge(KickTurning):
    HAND_KICK_DISTANCE = 150
    def __init__(self):
        KickTurning.__init__(self)
        self.theKick = None
        
    def calculateDesiredHeading(self):
        #decide the heading
        oppMeTM = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos+teammatePos+myPos))
        headingAwayFromOpp = HelpShort.extendToLimit(oppMeTM,45)
        self.desiredHeading = opponentToMe + headingAwayFromOpp
        
        #decide the kick
        if HelpShort.distanceToEdge(*(ballPos + (self.desiredHeading,))) > self.HAND_KICK_DISTANCE \
            or not HelpWhere.isOnTheField(*(teammatePos + (50,))): #there's alot of space or teamate is near the edge
            self.theKick = RandomKick()
        else:
            if oppMeTM > 0: 
                self.theKick = Constant.UpennRightWT
                self.desiredHeading -= UP_OFFSET
            else:
                self.theKick = Constant.UpennLeftWT
                self.desiredHeading += UP_OFFSET
                
        turnCCW = HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)
        print "turnCCW = ",turnCCW, " my heading = ", myHeading
        if abs(turnCCW) < MINIMUM_KICK_TURNING_ANGLE:
            if turnCCW * oppMeTM > 0:
                turnCCW = HelpShort.extendToLimit(turnCCW,MINIMUM_KICK_TURNING_ANGLE)
            else:
                turnCCW = 0
            print "adjusted = " , turnCCW
        
        self.desiredHeading = HelpShort.normalizeAngle_0_360(myHeading + turnCCW)
        print "desiredHeading = " , self.desiredHeading
        print "My Pos = ",myPos
        print "desiredHeading=",self.desiredHeading
        print "oppMeTM : ", oppMeTM, " d = " , opponentMeD

    def doTheKick(self):
        Global.finalAction[Constant.AAWalktype] = self.theKick
        HelpLong.setForceStepComplete()
        
    def finishAction(self):
        KickTurning.finishAction(self)
        self.doTheKick()
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_PULLING_OFF_EDGE)
        Global.finalAction = self.walkParams[:]
        if self.counter >= self.turningTime:
            return self.outState
        else:
            return self

            
def opponentDogInClose():
    return opponentBallD < myBallDistance + 50
    
class SmartWaiting(StateBasedAction):
    TURNING_RIGHT_720 = 16.7
    TURNING_LEFT_720 = 17.0
    def __init__(self):
        StateBasedAction.__init__(self)
        self.panningHead = PanningHead()
        self.panningHead.setRange( (90,-20,-20,Constant.HTAbs_h) , (-90,-20,-20,Constant.HTAbs_h) )
    
    def calculateGetBehindDirection(self):
        if HelpWhere.isOnLEdge(30) and (
            HelpWhere.isInRange(45,135) or HelpWhere.isInRange(225,315)):
            desiredHeading = 180
        elif HelpWhere.isOnREdge(30) and (
            HelpWhere.isInRange(45,135) or HelpWhere.isInRange(225,315)):
            desiredHeading = 0
        elif HelpWhere.isOnTEdge(30) and not (
            HelpWhere.isInRange(45,135) or HelpWhere.isInRange(225,315)):
            desiredHeading = 90
        elif HelpWhere.isOnBEdge(30) and not (
            HelpWhere.isInRange(45,135) or HelpWhere.isInRange(225,315)):
            desiredHeading = 270
        else:
            desiredHeading = myHeading
        turnNeeded = HelpShort.normalizeAngle_180(desiredHeading - myHeading)
        if turnNeeded > 0:
            self.forward = 0
            self.left = -5
            self.turnCCW = 12
            self.turningTime = self.TURNING_LEFT_720 * 30 / (720.0 / abs(turnNeeded))
        elif turnNeeded < 0:
            self.forward = 0
            self.left = 5
            self.turnCCW = -12
            self.turningTime = self.TURNING_RIGHT_720 * 30 / (720.0 / abs(turnNeeded))
        else:
            self.forward = 0
            self.left = 0
            self.turnCCW = 0
            self.turningTime = 0
            
        print "Turnning : ", self.turningTime, turnNeeded, self.left, self.turnCCW
        
    def beginAction(self):
        self.firstLeft = True
        self.firstRight = True
        self.irLeft = 0
        self.irRight = 0
        self.danger = None
        self.calculateGetBehindDirection()
    
    def doMyGetBehind(self):
        if self.counter < self.turningTime:
            HelpLong.setNormalWalk(self.forward,self.left,self.turnCCW)
        else:
            HelpLong.setNormalWalk(0,0,0)
            
    def DoAction(self):
        self.doMyGetBehind()
        self.panningHead.DoAction()
        irD = VisionLink.getAnySensor(Constant.ssINFRARED_NEAR)
        if Global.degPan > 79 :
            if self.firstLeft:
                self.irLeft = irD 
                self.firstLeft = False
                print "First IR Left = ",self.irLeft, Global.degPan
            elif ( irD < self.irLeft - 100000 or
                (self.irLeft - 50000.0) > (irD - 50000.0) * 1.8):
                print "Danger detected left ", self.irLeft, irD, (self.irLeft - 50000.0) , (irD - 50000.0)
                self.danger = Constant.dCLOCKWISE
                return self.outState
        elif Global.degPan < -79 :
            if self.firstRight:
                self.irRight = irD 
                self.firstRight = False
                print "First IR Right = ",self.irRight, Global.degPan
            elif (irD < self.irRight - 100000 or
                (self.irRight - 50000.0) > (irD - 50000.0) * 1.8):
                #100000 = 10 cm
                print "Danger detected right", self.irRight, irD,(self.irRight - 50000.0) , (irD - 50000.0)
                self.danger = Constant.dANTICLOCKWISE
                return self.outState
            
        return self
        
    def queryOpponentDirection(self):
        return self.danger
        
class WatchingOut(StateBasedAction):
    SAFE_BALL_DISTANCE = 18
    def __init__(self):
        StateBasedAction.__init__(self)
    
    def DoAction(self):
        HelpLong.showFacePattern(FP_WATCHING_OUT)
        HelpLong.setNormalWalk(0,0,0)
        HelpTrack.spinningLocalise()
        meToOppHeading = HelpShort.normalizeAngle_0_360(opponentToMe + 180)
        if Global.lostBall == 0 and Global.ballD > WatchingOut.SAFE_BALL_DISTANCE:
            return None
        elif abs(HelpShort.normalizeAngle_180(meToOppHeading - ballToMe)) >= 20\
            and Global.lostBall == 0 :
            return self.outState
        else:
            return self
        
class BlockTurning(KickTurning):
    def __init__(self):
        KickTurning.__init__(self)
        
    def beginAction(self): #over ride KickTurning to calculate desiredHeading..
        self.desiredHeading = HelpShort.normalizeAngle_0_360( HelpShort.getHeadingBetween(*(opponentPos + myPos)) )
        print "Desired H = ",self.desiredHeading," My H = ",myHeading
        HelpLong.setForceStepComplete()
        self.bHeadingRightDir = False
        self.calculateTurningTime()      
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_BLOCK_TURNING)
        if self.turningTime < 15:#dont turn if it's too small
            return self.outState
        else:
            return KickTurning.DoAction(self)
        

class SmartBlockingDog(StateBasedAction):
    def __init__(self,mySTOP_POINT = STOP_POINT,mySLOW_DOWN_POINT = SLOW_DOWN_POINT):
        StateBasedAction.__init__(self)
        self.mySLOW_DOWN_POINT = mySLOW_DOWN_POINT
        self.mySTOP_POINT = mySTOP_POINT
        
        self.doGetBehindBall = GetBehindBallBlockingBall(mySLOW_DOWN_POINT-5)
        self.doWatchingOut = WatchingOut()
        self.doApproaching = ApproachingBall(mySTOP_POINT,mySLOW_DOWN_POINT)
        self.doGrabBall = MyGrabBall()
        self.doTurning = BlockTurning()
        
        self.doWatchingOut.setOutState(self.doApproaching)
        self.doApproaching.setOutState(self.doGrabBall)
        self.doGrabBall.setOutState(self.doTurning)
        self.doTurning.setOutState(self.doWatchingOut)
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_SMART_BLOCKING)
        if self.subState is None:
            if Global.lostBall == 0:
                self.doSubState(self.doGetBehindBall)
            else:
                return None
        else:
            if self.subState == self.doGetBehindBall and \
                Global.ballD < self.mySLOW_DOWN_POINT:
                self.doSubState(self.doApproaching) 
            elif self.subState == self.doApproaching and \
                self.doGrabBall.shouldGrabTheBall():
                self.doSubState(self.doGrabBall)
            else:
                self.doSubState()
        return self #this is passive state, always return self
    
CENTER_POINT = (Constant.FIELD_WIDTH/2,Constant.FIELD_LENGTH/2)
def myRunningDirection():
    h = HelpShort.getHeadingBetween(*(myPos + CENTER_POINT))
    if HelpShort.normalizeAngle_180(myHeading - h) < 0:
        return Constant.dANTICLOCKWISE
    else:
        return Constant.dCLOCKWISE
    
class RunAway(StateBasedAction):
    LOST_BALL_TOO_MUCH = 20 # = active localising time
    SLOW_DOWN_POINT = 25
    STOP_POINT = 10
    def __init__(self):
        StateBasedAction.__init__(self)
        self.turnKick = TurnKick()
        self.hoverToBall = MyHoverToBall()
        self.doApproaching = ApproachingBall(RunAway.STOP_POINT,RunAway.SLOW_DOWN_POINT)
        self.doPawKick = MyPawKick()
        
    def chooseSmartTurnKickDirection(self):
        meBallOpp = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(myPos + opponentPos + ballPos))
        meBallTM  = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(myPos + teammatePos + ballPos))
        runToTM = False
        if meBallOpp * meBallTM < 0 or \
            abs(meBallOpp) < 10 : #different sides
            runToTM = True
        else:
            if abs(meBallOpp) > 45:
                runToTM = False
            else:
                if opponentMeD < 100:
                    runToTM = False
                else:
                    runToTM = True
                    
        if runToTM:
            if meBallTM > 0: return Constant.dCLOCKWISE
            else: return Constant.dANTICLOCKWISE
        else:
            if meBallTM > 0: return Constant.dANTICLOCKWISE
            else: return Constant.dCLOCKWISE
            
                    
            
            
    def DoAction(self):
        self.hoverToBall.DecideNextAction() #friend state
        
        HelpLong.showFacePattern(FP_RUN_AWAY)
        
        if Global.lostBall >= RunAway.LOST_BALL_TOO_MUCH:
            return None
        
        ballToOppDir = HelpShort.normalizeAngle_0_360(opponentToBall + 180)
        oppBallMe = HelpShort.angleBetweenTwoPointsFromPivotPoint( *(opponentPos + myPos + ballPos) )
        if abs(oppBallMe) > 60 and abs(oppBallMe) < 120:
            self.doSubState(self.doPawKick)
        elif Global.lostBall == 0 and not HelpWhere.isOnTheField(ballPos[0],ballPos[1],20):
            if Global.ballD < 16:
                direction = self.chooseSmartTurnKickDirection()            
                self.turnKick.setTurnDir(direction)
                self.doSubState(self.turnKick)
            else:
                self.doSubState(self.doApproaching)
        elif (Global.lostBall == 0 and 
            Global.ballD > RunAway.SLOW_DOWN_POINT and
            abs(HelpShort.normalizeAngle_180(ballToOppDir - ballToMe)) > 15):
            GetBehindBall.getBehindBall(RunAway.SLOW_DOWN_POINT, ballToOppDir  , Constant.dAUTO)
            
        return self #passive state always return self
          
OPPONENT_IS_CLOSE_BEHIND = 50
class BlockingDog(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doBlocking = SmartBlockingDog(10,25)
        self.runAWay = RunAway()
        
    def shouldRunAway(self):
        if False: #canSafelyPassToTeammate():  #can pass
            return False
        else:
            if isInTopBottomEdge(*myPos): #near goal
                return False
            else:
                if HelpShort.distanceToEdge(*(ballPos + (ballToMe,))) > 50:
                    return True
                else:                    
                    if opponentBallD < OPPONENT_IS_CLOSE_BEHIND : 
                        return True
                    else:
                        return False
                    
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_BLOCKING_DOG)
        if self.subState is None:
            if Global.lostBall <= 15:
                self.doSubState(self.doBlocking)
            else:
                return None
        else:
            if self.shouldRunAway():
                self.doSubState(self.runAWay)
            else:
                self.doSubState(self.doBlocking)
        return self
            
class DribbleTowardTeammate(StateBasedAction):
    LOST_BALL_TOO_MUCH = 2
    def __init__(self):
        StateBasedAction.__init__(self)
        self.turnKick = TurnKick()
        self.turnKick.setTurnDir(Constant.dCLOCKWISE)
        self.doApproaching = ApproachingBall()
        self.myHoverToBall = MyHoverToBall()
        
    def DoAction(self): 
        HelpLong.showFacePattern(FP_DRIBBLING_TO_TM)
        if Global.lostBall < DribbleTowardTeammate.LOST_BALL_TOO_MUCH:
            if Global.ballD < 16:
                oppBallMe = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos+teammatePos+ballPos))
                if oppBallMe > 10: #hesteresis (-10,10)
                    self.turnKick.setTurnDir(Constant.dANTICLOCKWISE)
                elif oppBallMe < -10:
                    self.turnKick.setTurnDir(Constant.dCLOCKWISE)
                self.doSubState(self.turnKick)
            else:
                self.myHoverToBall.DecideNextAction() #friend
                self.doSubState(self.doApproaching)
            return self
        else:
            return None
     
#should I pass? near the edge
def shouldPassNearEdge():
    tmVsOpp = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + teammatePos + ballPos))
    meVsOpp = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + myPos + ballPos))
    Debug.showDebug("tmVsOpp = %d meVsOpp = %d" % (tmVsOpp, meVsOpp))
    if ( (oppTeammateD > 100 or teammateMeD > 100) and  
        ( (tmVsOpp * meVsOpp > 0 and (abs(tmVsOpp) > abs(meVsOpp) or abs(tmVsOpp) > 45 ) ) or \
          (tmVsOpp * meVsOpp < 0 and abs(tmVsOpp) > 30 ) ) ):             
          return True 
    else:
        return False
        
#TOBE TESTED
#Handle ball after grabbing, in EdgeBallState
#TODO: put BallHoldingLocalise here
class HandleEdgeBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.pullBallOffEdge = PullBallOffEdge()
        self.successfulState = SuccessfulState()
        self.pullBallOffEdge.setOutState(self.successfulState)
      
    def shouldHoldAndWait(self):
        return opponentBallD > 150 and not shouldPassNearEdge()
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_HANDLE_EDGE_BALL)
        if self.subState is None:
            self.doSubState(self.pullBallOffEdge)
        else:
            self.doSubState()
        
        if self.subState is None:
            return None
        elif self.subState == self.successfulState:
            return self.outState
        else:
            return self
        
class EdgeBallState(StateBasedAction):
    APPROACHING_DISTANCE = 25
    def __init__(self):
        StateBasedAction.__init__(self)

        self.myHoverToBall = MyHoverToBall()
        self.doApproaching = ApproachingBall(10,self.APPROACHING_DISTANCE)
        self.doBlockingDog = BlockingDog()
        self.doGrabBall = MyGrabBall()
        self.handleEdgeBall = HandleEdgeBall()
        self.dibbleTowardTM = DribbleTowardTeammate()
        
        
        self.doApproaching.setOutState(self.doGrabBall)
        self.doGrabBall.setOutState(self.handleEdgeBall)
        
        self.debug = False
    
    
    
    #should I block?
    #should I prepare to pass, and wait for the opp to come.
    #return False if it should pass, True if it should block
    def shouldBlockOrPass(self):
        return not shouldPassNearEdge()
    
    def shouldDribbleTowardTM(self):
        #if opp is close and cannot pass, and tm is not too close
        return opponentBallD < 100 and not shouldPassNearEdge() \
            and teammateMeD > 70
    
    
        
    def DoAction(self):
        if self.subState is None:     
            HelpLong.showFacePattern(FP_EDGE_BALL)
            if Global.lostBall > 5:
                return self.outState
            
            if self.shouldDribbleTowardTM():
                self.doSubState(self.dibbleTowardTM)
            else:
                self.doSubState(self.myHoverToBall)
        else:
            if self.shouldDribbleTowardTM():
                self.doSubState(self.dibbleTowardTM)
            elif self.subState == self.myHoverToBall and \
                Global.ballD < self.APPROACHING_DISTANCE:
                self.doSubState(self.doApproaching)
            elif self.subState == self.doApproaching and \
                self.shouldBlockOrPass():
                if self.debug: print "BlockingDog"
                self.doSubState(self.doBlockingDog)
            elif self.subState == self.doApproaching and \
                self.doGrabBall.shouldGrabTheBall():
                if self.debug: print "GrabBall"
                self.doSubState(self.doGrabBall)
            else:
                self.doSubState()
        return self

class PKApproachingBall(StateBasedAction):
    PAW_KICK_RADIUS         = 3 #7.5
    def __init__(self):
        StateBasedAction.__init__(self)
        self.paw = None
        
    def setPaw(self,paw):
        self.paw = paw
        
    def DoAction(self):
        h = VisionLink.getBallHeading()
        d = VisionLink.getBallDistance()
            
        offHeading = HelpShort.RAD2DEG( math.asin(PKApproachingBall.PAW_KICK_RADIUS/d) )
##~         print "h = %3.1f , off = %3.1f " % (h,offHeading),
        if (self.paw == PawKick.FIRE_PAWKICK_RIGHT):
            h += offHeading
        else:
            h -= offHeading
        turnCCW = HelpShort.CLIP(h, 40)
        
        if abs(h) > 40:
            HelpLong.setNormalWalk(7,0,turnCCW)
        elif abs(h) < 20: #hesteresis (20,40)
            HelpLong.setEllipticalWalk(None,None,turnCCW)
        return self
##~         print " turn = %3.1f" % self.lastCommand[Constant.AATurnCCW]
        
LEFT_THRESHOLD  = (3,-7)
RIGHT_THRESHOLD = (7,-3)
DIST_THRESHOLD_FAR  = 18
DIST_THRESHOLD_NEAR  = 14
SIDE                = (-1,1)
OFFSET = 10
class UPKickingBall(StateBasedAction):
    UP_RIGHT    = 0
    UP_LEFT     = 1
    PAW         = (PawKick.FIRE_PAWKICK_RIGHT,PawKick.FIRE_PAWKICK_LEFT)
    SLOW_DOWN_POINT = 30
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doPKApproaching = MyPawKick()
        
    def doUpennKick(self):
##~         HelpLong.setForceStepComplete()
        Global.finalAction[Constant.AAWalktype] = self.whichUP + Constant.UpennRightWT
    
    def setKick(self,whichUP):
        self.whichUP = whichUP
        
    def shouldUPKick(self):
        if Global.ballD <= DIST_THRESHOLD_NEAR:
            return localBallX * SIDE[self.whichUP] > 0
        elif Global.ballD <= DIST_THRESHOLD_FAR:
            return (localBallX > LEFT_THRESHOLD[self.whichUP] and
                localBallX < RIGHT_THRESHOLD[self.whichUP])
        else:
            return False
            
    def DoAction(self):
        if Global.lostBall == 0:
            HelpTrack.trackVisualBall()
            if self.shouldUPKick():
                print "D = ",Global.ballD, "x = ",localBallX
                self.doUpennKick()
                return self.outState
            else:
                self.doPKApproaching.setPaw(UPKickingBall.PAW[self.whichUP])
                self.doSubState(self.doPKApproaching)
                turnCCW = Global.finalAction[Constant.AATurnCCW]
                if Global.ballD < UPKickingBall.SLOW_DOWN_POINT:
                    HelpLong.setForceStepComplete()
                    setNormalSlowWalk(5,0,turnCCW) #just to change walktype
                return self
        else:
            return None


class PanicBallState(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
##~         self.myHoverToBall = MyHoverToBall()
        self.upKickBall = UPKickingBall()
        self.pawKick = MyPawKick()
        
    def beginAction(self):
        self.upKickBall.setOutState(self.outState)
        
    def shouldPawKickQuickly(self):
        oppBallMe = HelpShort.angleBetweenTwoPointsFromPivotPoint( *(opponentPos + myPos + ballPos) )
        if HelpWhere.isOnTheField(*(ballPos + (30,))) and \
            abs(oppBallMe) < 150:
            return True
        elif opponentBallD > 20:            
            angle = abs( abs(oppBallMe) - 90)
            frontDistance = HelpShort.distanceToEdge(*(myPos + (myHeading,)))
            if self.subState == self.pawKick: #hesteresis (20,40)
                return frontDistance > 60 and abs(oppBallMe) < 90 #there's room and the opp  is left behind
            else:
                return angle < 20
        else:
            return False
        
    def DoAction(self):
        
        HelpLong.showFacePattern(FP_PANIC_BALL_STATE)
        if self.shouldPawKickQuickly():
            if not HelpWhere.isOnTheField(*(myPos + (30,))):
                self.pawKick.setPawKickNearEdge()
            else:
                self.pawKick.setPaw(PawKick.FIRE_PAWKICK_AUTO)
            self.doSubState(self.pawKick)
        else:
            #decide upenn target
            ballToOppDir = HelpShort.normalizeAngle_0_360(opponentToBall + 180)
    ##~         print "opp =",ballToOppDir, " me = ", Global.ballH," diff =",HelpShort.normalizeAngle_180( ballToOppDir - Global.ballH)
            if HelpShort.normalizeAngle_180( ballToOppDir - ballToMe) > 0:
                self.upKickBall.setKick(UPKickingBall.UP_RIGHT)
            else:
                self.upKickBall.setKick(UPKickingBall.UP_LEFT)
            self.doSubState(self.upKickBall)
            
        if self.subState is None:
            return None
        else:
            return self
        
class TeammateTooCloseState(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.blockingDog = BlockingDog()
        
    def DoAction(self):
        self.doSubState(self.blockingDog)
        return self

def inRange(x,min,max):
    return x >= min and x <= max
    

class KeepAway(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.upKickBall =UPKickingBall()
        self.pawKick    = MyPawKick()
    
    def shouldRunAway(self):
        #if dog is behind and there's room in front
        
        angle = HelpShort.normalizeAngle_0_360(ballToMe - opponentToMe)# = oppMeBall
        if angle > 160 and angle < 200 and \
            HelpShort.distanceToEdge(*(ballPos + (ballToMe,))) > 200:
            return True
            
        return False
            
    def canUPPass(self,oppBallMe, meBallTM):
        #if opponent is behind and teammate is in "UP angle"
        #oppBallMe could be replaced by oppMeBall, need testing
        return abs(oppBallMe) < 90 and inRange( 180 - abs(meBallTM) ,20 , 60 )
        
    def DoAction(self):
        #decide upenn goal
        HelpLong.showFacePattern(FP_KEEP_AWAY)
        ballToOppDir = HelpShort.normalizeAngle_0_360(opponentToBall + 180)
##~         print "opp =",ballToOppDir, " me = ", Global.ballH," diff =",HelpShort.normalizeAngle_180( ballToOppDir - Global.ballH)
        oppBallMe = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + myPos + ballPos))
        meBallTM  = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(myPos + teammatePos + ballPos))
##~         print "oppBallMe = ",oppBallMe, " meBallTM = " , meBallTM, " canUPPass = ",self.canUPPass(oppBallMe, meBallTM),\
##~             " shouldRunAway = ",self.shouldRunAway()
        if self.canUPPass(oppBallMe, meBallTM):
            if meBallTM < 0 :
                self.upKickBall.setKick(UPKickingBall.UP_RIGHT)
            else:
                self.upKickBall.setKick(UPKickingBall.UP_LEFT)
            self.doSubState(self.upKickBall)
        elif self.shouldRunAway():
            if not HelpWhere.isOnTheField(*(myPos + (30,))):
                self.pawKick.setPawKickNearEdge()
            else:
                self.pawKick.setPaw(PawKick.FIRE_PAWKICK_AUTO)
            self.doSubState(self.pawKick)
        else:
            if HelpShort.normalizeAngle_180( ballToOppDir - ballToMe) > 0:
                self.upKickBall.setKick(UPKickingBall.UP_RIGHT)
            else:
                self.upKickBall.setKick(UPKickingBall.UP_LEFT)
            self.doSubState(self.upKickBall)
            
        if self.subState is None:
            return self.outState
        else:
            return self
    
#null state to indicate something is done successfully. ( set this to the state's outState)
class SuccessfulState(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        

PARALLEL_ANGLE = 15
class RunToGrabBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        #avoid hitting edge here !
        self.doGetBehindBall = MyGetBehindBall()
        self.myHoverToBall = MyHoverToBall()
        self.doApproaching = ApproachingBall()
        self.doGrabBall = MyGrabBall()
        self.successfulState = SuccessfulState()
        
        self.myHoverToBall.setOutState(self.doApproaching)
        self.doApproaching.setOutState(self.doGrabBall)
        self.doGrabBall.setOutState(self.successfulState)
        
    #if i'm kind of parallel to the edge
    def canNotGrabNearTheEdge(self):
        if isInTopBottomEdge(*(myPos + (20,))):
            return abs(myHeading) < PARALLEL_ANGLE or \
                abs(myHeading - 180) < PARALLEL_ANGLE
        elif isInLeftRightEdge(*(myPos + (20,))):
            return abs(myHeading - 90) < PARALLEL_ANGLE or \
                abs(myHeading - 270) < PARALLEL_ANGLE
        else:
            return False
            
    def getApproachingDirectionNearEdge(self):
        if HelpWhere.isInTopLeftCorner(*myPos):
            return 135
        elif HelpWhere.isInTopRightCorner(*myPos):
            return 45
        elif HelpWhere.isInBottomLeftCorner(*myPos):
            return 225
        elif HelpWhere.isInBottomRightCorner(*myPos):
            return 315
        elif HelpWhere.isInTopEdgeCorner(*myPos):
            return 90
        elif HelpWhere.isInBottomEdgeCorner(*myPos):
            return 270
        elif HelpWhere.isInRightEdgeCorner(*myPos):
            return 0
        else: #HelpWhere.isInLeftEdgeCorner(*myPos):
            return 180
        
        
            
    def DoAction(self):
        if Global.lostBall == 0:
            HelpTrack.trackVisualBall()
            
        if self.subState is None:
            self.doSubState(self.myHoverToBall,immediate = False)
           
        if self.subState == self.myHoverToBall and \
            Global.lostBall == 0 and Global.ballD < 40 and \
            self.canNotGrabNearTheEdge():
##~             print "Getting behind ",self.getApproachingDirectionNearEdge()
            self.doGetBehindBall.setParameters(25,self.getApproachingDirectionNearEdge())
            self.doSubState(self.doGetBehindBall, immediate = False)
        elif self.subState in [self.myHoverToBall, self.doGetBehindBall] and \
            Global.lostBall == 0 and Global.ballD < SLOW_DOWN_POINT:
            self.doSubState(self.doApproaching, immediate = False)
        elif self.subState == self.doApproaching and  \
            self.doGrabBall.shouldGrabTheBall():
                self.doSubState(self.doGrabBall, immediate = False)
        elif self.subState == self.myHoverToBall and Global.lostBall > 0:
            return None
                
        if self.subState is None:
            return None
        else:
            self.doSubState()
            if self.subState == self.successfulState:
                return self.outState
            return self
        
class TurnPassingToTarget(KickTurning):
    def __init__(self):
        KickTurning.__init__(self)
        
    def setTarget(self,targetX,targetY):
        self.target = targetX,targetY
        
    def calculateDesiredHeading(self):
        oppMeTarget = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(opponentPos + self.target + myPos))

        self.desiredHeading = HelpShort.getHeadingBetween(*(myPos + self.target))
        turnCCW = HelpShort.normalizeAngle_180(self.desiredHeading - myHeading)
        print "turnCCW = ",turnCCW, " my heading = ", myHeading
        if abs(turnCCW) < MINIMUM_KICK_TURNING_ANGLE:
            if turnCCW * oppMeTarget > 0:
                turnCCW = HelpShort.extendToLimit(turnCCW,MINIMUM_KICK_TURNING_ANGLE)
            else:
                turnCCW = 0
            print "adjusted = " , turnCCW
        
        self.desiredHeading = HelpShort.normalizeAngle_0_360(myHeading + turnCCW)
        print "desiredHeading = " , self.desiredHeading

        
class TurnPassingBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doRunToGrabBall = RunToGrabBall()
        self.doTurnPassingToTarget = TurnPassingToTarget()
        self.kickBall = KickBall()
        
        self.doRunToGrabBall.setOutState(self.doTurnPassingToTarget)
        self.doTurnPassingToTarget.setOutState(self.kickBall)
        
    def setTarget(self,x,y):
        self.doTurnPassingToTarget.setTarget(x,y)
        
    def DoAction(self):
        if self.subState is None:
            self.doSubState(self.doRunToGrabBall)
        else:
            self.doSubState()
            if self.subState is None:
                return None
            else:
                return self
        
class SmartPassing(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doTurnPassingBall = TurnPassingBall() 
        self.upKickBall = UPKickingBall()
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_SMART_PASSING)
        if self.subState is None or  \
            (Global.lostBall == 0 and Global.ballD > 50): #only decide it's not too close
            meBallTM  = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(myPos + teammatePos + ballPos))
            if abs( 180 - abs(meBallTM) - UP_KICK_ANGLE) < 15: #if good to do Upenn
                if meBallTM > 0:
                    self.upKickBall.setKick(UPKickingBall.UP_LEFT)
                else:
                    self.upKickBall.setKick(UPKickingBall.UP_RIGHT)
                self.doSubState(self.upKickBall)
            else:
                target = getSafePositionToPassToTeammate()
                self.doTurnPassingBall.setTarget(*target)
                Debug.showDebug("target %s" % str(target),True)
                self.doSubState(self.doTurnPassingBall)
        else:
            self.doSubState()
        
        if self.subState is None:
            return self.outState
        else:
            return self

#active
class ControllingBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.normalBallState = NormalBallState()
        self.edgeBallState = EdgeBallState()
        self.panicBallState = PanicBallState()
        self.teammateTooCloseState = TeammateTooCloseState()
        self.keepAway = KeepAway()
        self.smartPassing = SmartPassing()
        
    def beginAction(self):
        self.doSubState(self.normalBallState,immediate = False)
        
    
    
    def shouldKeepAway(self): #assume that is cannot pass
        return opponentMeD < 100
        
    #hesteris "less than": if value <= min -> should be in theState, if already in theState, break out
    #onlywhen value > max
    def hesteresisLT(self,theState,value,min,max):
        if self.subState == theState :
            return value <= max
        else: # self.subState != theState 
            return value <= min
            
    def DoAction(self):
        #This is an example of active parent : decide no matter what 
        #the children do (Decisive parents)
        distanceToClosestEdge = HelpShort.getDistanceToClosestEdge(Global.ballX,Global.ballY)
##~         print "distanceToClosestEdge",distanceToClosestEdge, self.hesteresisLT(self.edgeBallState,distanceToClosestEdge,30,50)
        if Global.lostBall == 0: #the ball is critical, only decide when seeing it
            if Global.lostBall == 0 and canSafelyPassToTeammate():
                self.doSubState(self.smartPassing,immediate = False)
            elif isBallInDanger():
                self.doSubState(self.panicBallState,immediate = False)
            elif self.hesteresisLT(self.teammateTooCloseState, teammateMeD,30,50) : #hesteresis
                self.doSubState(self.teammateTooCloseState, immediate = False)
            elif self.hesteresisLT(self.edgeBallState,distanceToClosestEdge,30,50):
                self.doSubState(self.edgeBallState,immediate = False)
            elif self.shouldKeepAway():
                self.doSubState(self.keepAway,immediate = False)
            else: #HelpWhere.isOnTheField(x,y,50): #heteresis = (30,50)
                self.doSubState(self.normalBallState,immediate = False)
            
            
                
        if self.subState is not None:    
            self.doSubState()
            return self
        else :
            return self.outState
        
class TurningToTeammateBall(StateBasedAction):
    TIME_OUT = 150 #follow tm ball for 5 seconds
    def __init__(self):
        StateBasedAction.__init__(self)
        self.tmBall = (Global.sharedBallX,Global.sharedBallY)
            
    def DoAction(self):
        HelpLong.showFacePattern(FP_TURNING_TO_TM_BALL)
        #store it in case tm loses it
        if Global.ballSource == Constant.WIRELESS_BALL:
            self.tmBall = (Global.sharedBallX,Global.sharedBallY)
            
        HelpTrack.stationaryLocalise(5,-60,60)
        h = HelpShort.getHeadingBetween(*(myPos + self.tmBall))
        if abs(h) > 30:
            HelpLong.setNormalWalk(0,0,HelpShort.CLIP(h,50))
        elif HelpShort.getDistanceBetween(*(myPos + self.tmBall)) > 50:
            HelpLong.setEllipticalWalk(0,0,HelpShort.CLIP(h,20))
        else:
            HelpLong.setNormalWalk(0,0,h)
        if (not teammateSeeingBall() and self.counter > self.TIME_OUT) \
            or self.counter > 2*self.TIME_OUT:
            return self.outState
        else:
            return self
        
#active
class LosingBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doLocateBall = MyLocateBall()
        self.turningToTeammateBall = TurningToTeammateBall()
        
        self.doLocateBall.setOutState(self.turningToTeammateBall)
        self.turningToTeammateBall.setOutState(self.doLocateBall)
        
    def DoAction(self):
        if Global.lostBall > 0:
            if teammateSeeingBall():
##~                 print " Teammate found ball" , Global.sharedBallX, Global.sharedBallY
                self.doSubState(self.turningToTeammateBall)
            else:
                if self.subState is None:
                    self.doSubState(self.doLocateBall)
                else:
                    self.doSubState()
            return self
        else:
            HelpTrack.trackVisualBall()
            return self.outState
       
class StepBack(StateBasedAction):
    def __init__(self,howLong = 0, forward = 0,left = 0,turnCCW = 0):
        StateBasedAction.__init__(self)
        self.timeout = howLong
        self.walkCommand = (forward,left,turnCCW)
        
    def DoAction(self):
        HelpLong.setNormalWalk(*self.walkCommand)
        HelpLong.setHeadParams(0,-60,40,Constant.HTAbs_h)
        if self.counter < self.timeout:
            return self
        else:
            return self.outState
        
def isInOwnHalf(_,y):
    return y < Constant.FIELD_LENGTH/2
     
class HoldTurning(KickTurning):
    def __init__(self):
        KickTurning.__init__(self)
        
    def calculateDesiredHeading(self):
        if isInOwnHalf(*myPos):
            self.desiredHeading = 90
        else:
            self.desiredHeading = 270
    
def isInsideGoalBox():
    return Global.vOGoal.getConfidence() > 0 and Global.vOGoal.getVobDistance() == 5 \
        or Global.vTGoal.getConfidence() > 0 and Global.vTGoal.getVobDistance() == 5

#TOBE TESTED
class FindBallUnderChin(StateBasedAction):
    LOOKING_DOWN = 5
    TIME_OUT = 60
    def __init__(self):
        StateBasedAction.__init__(self)
    def DoAction(self):
        if Global.lostBall == 0:
            HelpTrack.trackVisualBall()
            return self.outState
        else:
            if self.counter < FindBallUnderChin.LOOKING_DOWN:
                HelpLong.setHeadParams(0,-20,-20,Constant.HTAbs_h)
                return self
            elif self.counter < FindBallUnderChin.TIME_OUT:
                HelpTrack.spinningLocalise(speed = 8)
                return self
            else:
                return self.outState
        
        
class PullBallOffGoal(StateBasedAction):
    LOST_BALL_TOO_LONG = 60
    def __init__(self):
        StateBasedAction.__init__(self)
        self.doGrabBall = MyGrabBall()
        self.doApproaching = ApproachingBall(10,40)
        self.doStepBack = StepBack(30,-3,0,0)
        self.doTurning180 = HoldTurning()
        self.findBallUnderChin = FindBallUnderChin()
        
        self.doApproaching.setOutState(self.doGrabBall)
        self.doGrabBall.setOutState(self.doStepBack)
        self.doStepBack.setOutState(self.doTurning180)
        
    def DoAction(self):
        if self.subState is None:
            if Global.lostBall > 30:
                HelpTrack.spinningLocalise(speed = 10)
                HelpLong.setNormalWalk(-3,0,0)
                if self.counter > self.LOST_BALL_TOO_LONG:
                    return None
            else:
                self.doSubState(self.doApproaching)
        else:
            if self.subState == self.doApproaching and \
                ( self.doGrabBall.shouldGrabTheBall() or Global.lostBall > 0): #when approaching, the ball may be lost under chin
                    self.doSubState(self.doGrabBall)
            else:
                self.doSubState()
                
        if self.subState == None:
            return self.outState
        else:
            return self
           
def trackTarget(x,y):
    lx,ly = HelpShort.getLocalCoordinate(*(myPos + (myHeading,x,y)))
    HelpLong.setHeadParams(-lx,0,ly,Constant.HTAbs_xyz)
    
OBSTACLE_THRESHOLD = 100000
OBSTACLE_NOT_FOUND = 60

class GetOutOfStuck(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.lastBall = None
        
    def beginAction(self):
        if Global.lostBall == 0: #if pursueing ball, store it
            self.lastBall = ballPos
        else:
            self.lastBall = None
        self.minDistance = 1000000000
        self.panMin , self.panMax = -80,80
        self.found = False
        self.lastest30 = [(1000000,0)] * 30
    
    def finishAction(self):
        if self.lastBall is not None:
            trackTarget(*self.lastBall)
            
    def DoAction(self):
        HelpLong.showFacePattern(FP_GET_OUT_OF_STUCK)
        HelpTrack.spinningLocalise(True, -10, -10, 0,3, self.panMin,self.panMax)
        irDistance = VisionLink.getAnySensor(Constant.ssINFRARED_NEAR) 
        if not self.found and irDistance < OBSTACLE_THRESHOLD:
##~             print "Found ", Global.degPan, irDistance
            self.found = True
            self.panMin = max(Global.degPan - 30,-80)
            self.panMax = min(Global.degPan + 30,80)
            
        if self.found:
            center = (self.panMin + self.panMax) / 2
            centerRAD = HelpShort.DEG2RAD(center)
            forward = - math.cos(centerRAD) * 6
            left = -math.sin(centerRAD) * 6
            HelpLong.setNormalSideWalk(forward,left,0)
            self.lastest30.pop(0)
            self.lastest30.append((irDistance,Global.degPan))
            (minIR,minCenter) = min(self.lastest30)
            self.panMin = max(minCenter - 30,-80)
            self.panMax = min(minCenter + 30,80)
##~             print "minIR = ",minIR, " minCenter = " , minCenter, self.panMin , self.panMax 
            if minIR < OBSTACLE_THRESHOLD:
                return self
            else:
                
                return self.outState
                
        if self.counter > OBSTACLE_NOT_FOUND:
            
            return self.outState
        else:
            return self
        
class AttackerDog(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.controllingBall = ControllingBall()
        self.losingBall = LosingBall()
        self.doActiveLocalise = MyActiveLocalise()
        self.pullBallOffGoal = PullBallOffGoal()
        self.getOutOfStuck  = GetOutOfStuck()
        self.controllingBall.setOutState(self.losingBall)
        self.losingBall.setOutState(self.controllingBall)
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_ATTACK)
        
        #This is an example of "friend" state, it is executed along 
        # as long as this state is doing.
        self.doActiveLocalise.DecideNextAction() 
        if isInsideGoalBox():
            self.doSubState(self.pullBallOffGoal,immediate = False)
        elif stuckDetected == STUCK_VPULL:
            self.doSubState(self.getOutOfStuck,immediate = False)
        #This is an example of passive parent state (only decide if child states give up)
        if self.subState is None: #sub state is not active, decide  
            if Global.lostBall == 0:
                self.doSubState(self.controllingBall)
            else:
                self.doSubState(self.losingBall)
        else:
            self.doSubState()
        return self
        
attackerDog = AttackerDog()

def getTwoClosestBeaconHeadings(myX,myY,myH):
    beaconPos = [(0,0),
            (Constant.FIELD_WIDTH,0),
            (Constant.FIELD_WIDTH,Constant.FIELD_LENGTH),
            (0,Constant.FIELD_LENGTH)]
    panAngle = []
    for (x,y) in beaconPos:
        deg1 = HelpShort.getHeadingBetween( myX,myY,x,y) 
        h = HelpShort.normalizeAngle_180(deg1 - myH)
        panAngle.append( (h,x,y,30 ) )
    panAngle.sort(lambda x,y : cmp(abs(x[0]) , abs(y[0]) ) )
    return panAngle[:2]

TRACK_OPP_TIME = 40
ACTIVE_LOC_TIME = 50
TOTAL_TIME = 60
LOST_OPP_TRACK_FOR_TOO_LONG = 30
AWAY_FROM_OPP_DISTANCE = 100

class SupportHead(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        pass
        
    def trackOpponentRobot(self):
        h = HelpShort.getHeadingBetween(*(myPos+opponentPos))
        panx = HelpShort.normalizeAngle_180(h - myHeading)
        if abs(panx) < 90:
            HelpLong.setHeadParams(panx,0,0,Constant.HTAbs_h)
        
        
    def DoAction(self):
        if self.counter < TRACK_OPP_TIME:
            self.trackOpponentRobot()
        elif self.counter < ACTIVE_LOC_TIME:
            ActiveLocalise.SmartSetBeacon(90,500)
            ActiveLocalise.DecideNextAction(False)
        elif self.counter < TOTAL_TIME :
            HelpTrack.trackGpsBall()
        else:
            self.counter = 0
        return self
        

    
def runFastToPosition(x,y):
    heading = HelpShort.getHeadingBetween(*(myPos+(x,y)))
    turnCCW = HelpShort.normalizeAngle_180(heading - myHeading)
    if abs(turnCCW) > 30:
        turnCCW = HelpShort.CLIP(turnCCW,40)
        HelpLong.setNormalWalk(0,0,turnCCW)
    else:
        HelpLong.setEllipticalWalk(None,None,turnCCW/2)
            
CANNOT_FIND_BALL = 60
class ExpectBallFromTeammate(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.foundBall = False
        self.locateBall = MyLocateBall()
        
    def beginAction(self):
        self.foundBall = False
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_EXPECT_BALL_FROM_TM)
        if Global.lostBall == 0:
            self.foundBall = True
        
        if not self.foundBall:  
            if self.counter > CANNOT_FIND_BALL:
                self.doSubState(self.locateBall)
            else:
                expectedBall = HelpShort.getPointRelative(*(teammatePos + (teammateHeading,KICKED_BALL_DISTANCE)))
                runFastToPosition(*expectedBall)
                HelpTrack.stationaryLocalise()
        else:
            runFastToPosition(*ballPos)
        
        return self
       
def getTwoCirclePositioning(myX,myY, peerX,peerY,oppX,oppY, OPP_DISTANCE, PEER_DISTANCE):
        #find a point from the circle that is OPP_DISTANCE away from opponent
         #and PEER_DISTANCE from the temmate
         #among them choose the smallestDistance from current Pos
        tmVSoppD = HelpShort.getDistanceBetween(peerX,peerY,oppX,oppY)
        #scale up sothat the "angle" is not too large
        if tmVSoppD * 1.3 > PEER_DISTANCE + OPP_DISTANCE:
            sum = PEER_DISTANCE + OPP_DISTANCE #pycheker warning
            scale = tmVSoppD * 1.5 / sum
            PEER_DISTANCE *= scale
            OPP_DISTANCE *= scale
        
        pos1,pos2 = HelpShort.intersectCircle(peerX,peerY,PEER_DISTANCE, oppX,oppY, OPP_DISTANCE)
##~         Debug.showDebug("pos1 = %s , pos2 = %s" % (str(pos1), str(pos2)) )
        if HelpWhere.isOnTheField(*(pos1)) and \
            not HelpWhere.isOnTheField(*(pos2)):
            (x,y) = pos1
        elif HelpWhere.isOnTheField(*(pos2)) and \
            not HelpWhere.isOnTheField(*(pos1)):
            (x,y) = pos2
        elif HelpShort.getDistanceBetween(*(pos1 + (myX,myY))) < HelpShort.getDistanceBetween(*(pos2 + (myX,myY))):
            (x,y) = pos1
        else:
            (x,y) = pos2
        
        offset = 50
        length = Constant.FIELD_LENGTH
        width = Constant.FIELD_WIDTH
        x = HelpShort.CLIPTO(x,offset,width-offset)
        y = HelpShort.CLIPTO(y,offset,length-offset)
        
        return (x,y)

UNIVERSAL_POSITION = (Constant.FIELD_WIDTH/2,Constant.FIELD_LENGTH/2)

def getSmartPositioning(myX,myY, peerX,peerY,oppX,oppY, ballX,ballY, OPP_DISTANCE, PEER_DISTANCE):
    dangerDistance = HelpShort.getDistanceBetween(peerX,peerY, oppX,oppY)
    if dangerDistance > PEER_DISTANCE: #marking opp dog, get in the way of the opponent robot
        h = HelpShort.getHeadingBetween(ballX,ballY,oppX,oppY)
        (x,y) = HelpShort.getPointRelative(ballX,ballY,h,PEER_DISTANCE)
        Debug.showDebug("smart pos [marking] = %s" % str((x,y)) )
    elif dangerDistance < 50:
        h = HelpShort.getHeadingBetween(oppX,oppY,myX,myY)
        (x,y) = HelpShort.getPointRelative(oppX,oppY,h,OPP_DISTANCE)
        Debug.showDebug("smart pos [danger] = %s" % str((x,y)) )
        if not HelpWhere.isOnTheField(x,y):
            (x,y) = UNIVERSAL_POSITION
    else:
        (x,y) = getTwoCirclePositioning(myX,myY, peerX,peerY,oppX,oppY, OPP_DISTANCE, PEER_DISTANCE)
        Debug.showDebug("smart pos [normal] = %s" % str((x,y)) )
    return (x,y,HelpShort.getHeadingBetween(*(myPos+opponentPos)))
    
TOO_CLOSE_TO_OPPONENT   = 30
VERY_FAR_POSITION       = (10000,10000)

def getSupportingStrategyPosition():
    teammateToOpp = HelpShort.getHeadingBetween(*(opponentPos + teammatePos))
    dir1 = HelpShort.normalizeAngle_0_360(teammateToOpp + 90)
    dir2 = HelpShort.normalizeAngle_0_360(teammateToOpp - 90)
    pos1 = HelpShort.getPointRelative(*(opponentPos + (dir1,AWAY_FROM_OPP_DISTANCE)))
    pos2 = HelpShort.getPointRelative(*(opponentPos + (dir2,AWAY_FROM_OPP_DISTANCE)))
        
    stayStill = True
    pos1 = HelpShort.clipPosition(pos1)
    if HelpShort.getDistanceBetween(*(pos1 + opponentPos)) < TOO_CLOSE_TO_OPPONENT:
        pos1 = VERY_FAR_POSITION
    else:
        stayStill = False
    
    pos2 = HelpShort.clipPosition(pos2)
    if HelpShort.getDistanceBetween(*(pos2 + opponentPos)) < TOO_CLOSE_TO_OPPONENT:
        pos2 = VERY_FAR_POSITION
    else:
        stayStill = False
        
    Debug.showDebug("pos1 , pos2 " + str( (pos1,pos2) ) )
    if stayStill:
        return ( myPos + (opponentToMe,) )
    elif HelpShort.getDistanceBetween(*(pos1 + myPos)) < HelpShort.getDistanceBetween(*(pos2 + myPos)):
        Debug.showDebug("Picked pos1",True)
        
        return ( pos1+ (opponentToMe,) )
    else:
        Debug.showDebug("Picked pos2",True)
        return ( pos2+ (opponentToMe,) )

#supporter, if tm is in danger, mark opponent
def getBlockingPosition():
    ballToOppDir = HelpShort.normalizeAngle_0_360(opponentToBall + 180)
    pos = HelpShort.getPointRelative(*(opponentPos + (ballToOppDir, AWAY_FROM_OPP_DISTANCE)))
    return (pos[0],pos[1],opponentToBall)
    
CORNERS = [ (0,0) ,
            (Constant.FIELD_WIDTH, 0),
            (0,Constant.FIELD_LENGTH),
            (Constant.FIELD_WIDTH,Constant.FIELD_LENGTH) ]
CORNER_DISTANCE = 100
WAITING_DISTANCE = 150 / math.sqrt(2)
WAITING_POS = [ (WAITING_DISTANCE,WAITING_DISTANCE, 45) ,
            (Constant.FIELD_WIDTH - WAITING_DISTANCE, WAITING_DISTANCE , 135),
            (WAITING_DISTANCE,Constant.FIELD_LENGTH - WAITING_DISTANCE , -45),
            (Constant.FIELD_WIDTH - WAITING_DISTANCE,Constant.FIELD_LENGTH - WAITING_DISTANCE, -135) ]
            

def getCornerSupportingPosition():
    for i in range(len(CORNERS)):
        corner = CORNERS[i]
        if HelpShort.getDistanceBetween(*(corner + opponentPos)) < CORNER_DISTANCE:
            return WAITING_POS[i]
    return (None,None,None) #Weird
    
TIME_TO_FIND_OPP = 150
def haveSeenOpponentRecently():
    return Global.frame - lastOppSeenTime < TIME_TO_FIND_OPP

#TOBE TESTED
class RunToOpponentToFindOpp(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        meToOppHeading = HelpShort.normalizeAngle_0_360(opponentToMe + 180)
        closeOppPos = HelpShort.getPointRelative(*(opponentPos + (meToOppHeading, TOO_CLOSE_TO_OPPONENT)))
        runFastToPosition(*closeOppPos)
        HelpTrack.stationaryLocalise()
        if opponentMeD < TOO_CLOSE_TO_OPPONENT:
            return self.outState
        else:
            return self

#TOBE TESTED
TEAMMATE_DISTANCE = 100
class RunToTeammateToFindOpp(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        meToTMHeading = HelpShort.normalizeAngle_0_360(teammateToMe + 180)
        closeTMPos = HelpShort.getPointRelative(*(teammatePos + (meToTMHeading, TEAMMATE_DISTANCE)))
            
        if teammateMeD < TEAMMATE_DISTANCE:
            LocateBall.spinToSpot(*closeTMPos)
        else:
            runFastToPosition(*closeTMPos)
        return self 
            
#TOBE TESTED
class LocateOpponent(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        #if cannot find opponent in GPS , run to teammate pos to "guard"
        self.runToOpponentPos = RunToOpponentToFindOpp()
        self.runToTeammatePos = RunToTeammateToFindOpp()
        
        self.runToOpponentPos.setOutState(self.runToTeammatePos)
        self.runToTeammatePos.setOutState(self.runToOpponentPos) #redundant atm
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_LOCATE_OPPONENT)
        #   support get close to opponentPos before spinning
        if self.subState is None:
            self.doSubState(self.runToOpponentPos)
        else:
            self.doSubState()
        
        if haveSeenOpponentRecently():
            return self.outState
        else:
            return self
        
DANGER_BALL_DISTANCE = 30
class SmartSupporter(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def teammateIsInDanger(self):
        if opponentBallD  - teammateBallD < DANGER_BALL_DISTANCE or not teammateSeeingBall():
            return True
        return False
            
    def canObstructBall(self): 
        meOppBall = HelpShort.angleBetweenTwoPointsFromPivotPoint( *(myPos + ballPos + opponentPos) )
##~         print "meOppBall = ",meOppBall, " opponentBallD = ",opponentBallD
        return opponentBallD > 100 and abs(meOppBall) < 90
        
    def opponentIsInTheCorner(self):
        for corner in CORNERS:
            if HelpShort.getDistanceBetween(*(corner + opponentPos)) < CORNER_DISTANCE:
                return True
        return False
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_SMART_SUPPORTER)
        if Global.lostBall == 0 and Global.ballD < 30:
            HelpTrack.trackVisualBall()
##~         smartSupportingPosition = getSmartPositioning(*(myPos + teammatePos+ opponentPos + ballPos + (self.PEER_DISTANCE,self.OPP_DISTANCE)))
        if self.teammateIsInDanger() and self.canObstructBall():
            smartSupportingPosition = getBlockingPosition()
        elif self.opponentIsInTheCorner():
            smartSupportingPosition = getCornerSupportingPosition()
        else:
            smartSupportingPosition = getSupportingStrategyPosition()
        Debug.showDebug("running to %d %d %d" % smartSupportingPosition, True)
        (x,y,desiredHeading) = smartSupportingPosition
        
        d = HelpShort.getDistanceBetween(*(myPos + (x,y) ))
        tmD = HelpShort.getDistanceBetween(*(myPos + teammatePos))
        if d > 80 or tmD < 20 or opponentMeD < 30: #should not be near teammate, run away fast
            runFastToPosition(x,y)
        elif d > 20 or HelpShort.normalizeAngle_180(desiredHeading - myHeading) > 5: 
##~             print "Going to :",smartSupportingPosition
            HelpTrack.saGoToTargetFacingHeading(*smartSupportingPosition )
            
        #if lose track of opponent, turnaround to find it.
        if not haveSeenOpponentRecently():
            turnCCW = Global.finalAction[Constant.AATurnCCW]
            if abs(turnCCW) < 10:
                if turnCCW == 0: turnCCW = 1
                turnCCW *= 10/abs(turnCCW)
            HelpLong.setForwardLeftTurn(None,None,turnCCW) #turn around to find dog
            
        return self
        
#supporter moving toward the opponent while heading toward the ball sothat teammate can see it
class HelpTrackingBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_HELP_TRACKING_BALL)
        HelpTrack.trackVisualBall()
        meToOppHeading = HelpShort.normalizeAngle_0_360(opponentToMe + 180)
        (x,y) = HelpShort.getPointRelative(*(opponentPos + (meToOppHeading, AWAY_FROM_OPP_DISTANCE)))
        HelpTrack.saGoToTargetFacingHeading(x,y,ballToMe)
        return self
        
#TOBE TESTED
class RunToWaitingTeammate(StateBasedAction):
    CORNER_POS = [ (30,30) , (260,410) , (30,410), (260,30) ]
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        minDistanceFromTM = 10000000000
        pos = None
        for (x,y) in self.CORNER_POS:
            d = HelpShort.getDistanceBetween( *(teammatePos + (x,y) ) )
            if d < minDistanceFromTM:
                minDistanceFromTM = d
                pos = (x,y)
        runFastToPosition(*pos)
        return self #passive
        
class SupportDog(StateBasedAction):
    """
    go to the opposite side of the field, facing the otherdog
    """
    PEER_DISTANCE = 150
    OPP_DISTANCE = 100
    
    def __init__(self):
        StateBasedAction.__init__(self)
        self.supportHead = SupportHead()
        self.expectBallFromTeammate = ExpectBallFromTeammate()
        self.doLocateOpponent = LocateOpponent()
        self.doSmartSupporter = SmartSupporter()
        self.helpTrackingBall = HelpTrackingBall()
        self.runToWaitingTeammate = RunToWaitingTeammate()
        
        
    def DoAction(self):
        HelpLong.showFacePattern(FP_SUPPORT)

        self.supportHead.DecideNextAction()
        if teammateBehaviours.isKickedOff(): #tm has just kicked
            print "My Teammate just kicked"
            self.doSubState(self.expectBallFromTeammate)
        elif haveSeenOpponentRecently() and teammateBehaviours.isStriker(): #tm is holdingBall
            self.doSubState(self.runToWaitingTeammate)
        elif Global.lostBall == 0 and \
            ( haveJustKicked() or not teammateSeeingBall() ): #if i'm seeing ball then track it until teammate see it
            self.doSubState(self.helpTrackingBall)
        elif not haveSeenOpponentRecently():
            self.doSubState(self.doLocateOpponent)
        else:
            self.doSubState(self.doSmartSupporter)
            
        return self
        
supportDog = SupportDog()

lastKickTime  = -2
def setIHaveJustKicked():
    global lastKickTime
    lastKickTime = Global.frame
    setMessageBits(justKicked = True)
    print "setIHaveJustKicked"
    
def haveJustKicked(time = 60):
    return Global.frame - lastKickTime < time
    
CLOSE_BALL_DISTANCE = 200 #cm
CLOSER_TO_BALL_DISTANCE = 20
def shouldBecomeAttacker():
    if haveJustKicked(150):
        return isBallInDanger()
    else:
        if Global.lostBall == 0 or teammateSeeingBall():
            if teammateSeeingBall():
                return teammateBallD - Global.ballD > 2 * CLOSER_TO_BALL_DISTANCE
            else:
                return teammateBallD - Global.ballD > CLOSER_TO_BALL_DISTANCE
        else:
            return False

GIVING_UP_PERIOD = 60 #2 seconds, time to make sure the packet is reached 
givingUpCounter = GIVING_UP_PERIOD

BALL_DISTANCE_THRESTHOLD = 20

def shouldGiveUpAttacker():
    if Global.lostBall == 0:#if seeing ball 
        if teammateSeeingBall(): #trust wireless more
            return Global.ballD - teammateBehaviours.getBallDist() > BALL_DISTANCE_THRESTHOLD
        else:
            return Global.ballD - teammateBallD > BALL_DISTANCE_THRESTHOLD
    else:
        return Global.lostBall > 90
        
def teammateIsCloserToBallThanMe():
    if Global.lostBall == 0:
        return teammateBallD < Global.ballD
    else:
        return False

def teammateIsMuchCloserThanMe():
    if Global.ballSource == Constant.GPS_BALL:
        return False
    else:
        meBallTM  = HelpShort.angleBetweenTwoPointsFromPivotPoint(*(myPos + teammatePos + ballPos))
        if abs(meBallTM) < 20: #if we are aligned with the ball
            return Global.ballD - teammateBallD > 40
        else:
            return Global.ballD - teammateBallD > 100

CLOSER_TO_OPP_DISTANCE = 20
def iamCloserToOpponent():
    opponentTMD = HelpShort.getDistanceBetween(*(opponentPos + teammatePos))
    return opponentMeD - opponentTMD <  -CLOSER_TO_OPP_DISTANCE
    
#TOBE TESTED
def opponentIsFarAndTMisCloserThanOpp():
    return opponentBallD > 200 and opponentBallD - teammateBallD > 30
    
#determining switching roles
def determineMyRole():
    global myRole,givingUpCounter
    if myRole is None:
        setRole(SUPPORTER)
    
    if bNoDynamicRole: 
        return myRole
        
    if myRole == SUPPORTER:
        if givingUpCounter < GIVING_UP_PERIOD:
            setMessageBits(iamSupporter=True) #giving up attacker
            givingUpCounter += 1
            
        if teammateBehaviours.isBackOff(): #accept my request
            setRole(ATTACKER)
        elif shouldBecomeAttacker():
            setMessageBits(iamAttacker=True)
        elif teammateBehaviours.hasBall(): #got request, accept immediately
            setMessageBits(iamSupporter=True)
        elif teammate.getPosVar() == 10000.0: #if teammate is disappeared
            setMessageBits(iamAttacker=True)
            setRole(ATTACKER)
    else:
        if teammateBehaviours.hasBall() and shouldGiveUpAttacker(): #get a request
                print "shouldGiveUpAttacker"
                givingUpCounter = 0
                setRole(SUPPORTER)
        elif haveJustKicked() and \
            teammate.getPosVar() < HelpShort.get95cf(100) and \
            ( teammateIsCloserToBallThanMe() or \
              iamCloserToOpponent() or \
                opponentIsFarAndTMisCloserThanOpp() ) :#i have just kicked the ball
                print "justKicked, give up", iamCloserToOpponent()
                givingUpCounter = 0
                setRole(SUPPORTER)
        elif Global.selfLoc.getPosVar() < HelpShort.get95cf(100) and\
            teammate.getPosVar() < HelpShort.get95cf(100) and\
            teammateIsMuchCloserThanMe():
            print "teammateIsMuchCloserThanMe"
            givingUpCounter = 0
            setRole(SUPPORTER)
            setMessageBits(iamSupporter = True) #giving up attacker
            
    return myRole

#TODO: may not do support after Panic UPenn
KICK_TYPE_LIST = [Constant.UpennRightWT,Constant.UpennLeftWT,Constant.HandKickLeftWT,Constant.HandKickRightWT]


def detectKick():
    if Global.finalAction[Constant.AAWalktype] in KICK_TYPE_LIST:
        setIHaveJustKicked()

#TOBE TESTED
ballDistances = []
RUN_TO_BALL_MINIMUM_VELOCITY = 0.5 # 0.5cm  / frame = 15 cm / sec
STUCK_DIFF_THRESHOLD = 100
MINIMUM_PWM_THRESHOLD = 400
stuckCounter = 0 
STUCK_COUNTER_THRESHOLD = 10
NUMBER_OF_DATA  = 10
bDebugPWM = False
ellipticalWalkCounter = 0
def detectStuck():
    global ballDistances,stuckDetected, stuckCounter,ellipticalWalkCounter 
    oldPWM = lastMaxPWMValues.pop(0)
    lastMaxPWMValues.append(HelpLong.getMaxPWMDuty()[0])
    newPWM = lastMaxPWMValues[-1]
    if newPWM > MINIMUM_PWM_THRESHOLD and newPWM - oldPWM > STUCK_DIFF_THRESHOLD :
        stuckCounter += 1
        if bDebugPWM:
            print ".",newPWM, oldPWM
        if stuckCounter > STUCK_COUNTER_THRESHOLD:
##~             print "PWM stuck detected", newPWM, oldPWM
            stuckDetected = STUCK_PWM
        return 
    stuckCounter = 0
    if Global.finalAction[Constant.AAWalktype] == Constant.EllipseWalkWT:
        ellipticalWalkCounter += 1
    else:
        ellipticalWalkCounter = 0
        
    if Global.lostBall < 5 and ellipticalWalkCounter > 60: #run for at least 2 seconds
        ballDistances.append(Global.ballD)
        if len(ballDistances) > NUMBER_OF_DATA:
            ballDistances.pop(0)
        if len(ballDistances) >= NUMBER_OF_DATA: #enough to guess ball velocity
            vel = 0.0
            count = len(ballDistances)
            for i in range(len(ballDistances) - 1): 
                if ballDistances[i] - ballDistances[i+1] > 0:
                    vel += ballDistances[i] - ballDistances[i+1]
            if count == 0: count = 1
            
            vel /= count
            print "Vel = ",vel
            if vel < RUN_TO_BALL_MINIMUM_VELOCITY:
                stuckDetected = STUCK_VPULL
                print "Stuck Detected " , vel, count
                return
    else:
        ballDistances = []
    stuckDetected = False
    
    
def DecideNextAction():
    Global.frameReset()
    HelpLong.superDebug()
    FWHead.resetEachFrame()
    resetEachFrame()
    if determineMyRole() == ATTACKER:
        attackerDog.DecideNextAction()
    else:
        supportDog.DecideNextAction()
    
    detectKick()
##~     detectStuck()
##~     if stuckDetected == STUCK_VPULL:
##~         HelpLong.showHeadColor(Constant.RGB_YELLOW)
##~     elif stuckDetected == STUCK_PWM:
##~         HelpLong.showHeadColor(Constant.RGB_RED)
##~     else:
##~         HelpLong.showHeadColor(Constant.RGB_NO_COLOR)
        
    if wirelessCommand is not None:
        wirelessCommand()
        
    #send my behaviour to tmHoverToBall
    VisionLink.sendMyBehaviourInfo(sendBallDist, isStriker, isGoalie, haveBall, \
                                   kickedOff, isDefending, isBackOff)
                                   
def processCommand(cmd):
    global wirelessCommand
    wirelessCommand = None
    print "OpenChallenger got ", cmd
    if cmd == "sloc":
        wirelessCommand = HelpTrack.stationaryLocalise
        
initPlayer()
