#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: PenShooter.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




import HelpShort
import HelpLong
import HelpTrack
import Global
import Constant
import LocateBall
import PawKick
import Kick
import HoverToBall
import AttackerCruyff
import FWHead
import GetBehindBall

def getPlayerDescription():
    return __doc__
    
def DecideNextAction():

    #reset everything
    Global.DKD = HelpTrack.getDKDRange()
            
    HelpLong.setDefaultAction()
    HelpLong.setDefaultIndicators()
    Global.frameReset()
    FWHead.resetEachFrame()

    if HelpShort.canSeeBall():
        print "can see ball"
        if ballInRange():
            print " ball in range: %f" % (Global.ballD)
            FWHead.compulsoryAction = FWHead.mustSeeBall
            if goalHeadingInRange():
                print "  goal in range: %f" % (getGoalHeading())
                if not inOpponentHalf() or goalDistInRange():
                    "   self in wrong half or near goal -> paw kick"
                    PawKick.firePawKick(PawKick.FIRE_PAWKICK_AUTO)
                else:
                    "   self in right half -> dive kick"
                    Kick.diveKick()
            else:
                print "  goal not in range %f" % (getGoalHeading())
                GetBehindBall.getBehindBall(25,90,Constant.dAUTO)
        else:
            print ' ball not in range %f' % (Global.ballD)
            HoverToBall.DecideNextAction()
            AttackerCruyff.AttackerSlowDown(25,10,6,0);
    else:
        print "can't see ball"
        LocateBall.DecideNextAction()
        
    FWHead.DecideNextAction()

def canSeeGoal():
    return Global.vOGoal.getConfidence() > 0

def ballInRange():
    return Global.ballD <= 22

def goalDistInRange():
    if(canSeeGoal()):
        goalDist = Global.vOGoal.getDistance()
    else: #calculate gps position
        goalDist = HelpShort.getDistanceBetween(Global.selfLoc.getX(), Global.selfLoc.getY(), 
                    Constant.FIELD_WIDTH/2, Constant.FIELD_LENGTH)
    return goalDist <= 40

def goalHeadingInRange():
    return getGoalHeading() > -90 and getGoalHeading() < 90

def getGoalHeading():
    if canSeeGoal():
        return HelpShort.getHeadingBetween(Global.vBall.getX(), Global.vBall.getY(),
                                           Global.vOGoal.getX(), Global.vOGoal.getY())
        #return Global.vOGoal.getHeading()
    else:
        return HelpShort.getHeadingBetween(Global.ballX, Global.ballY, 
                                           Constant.FIELD_WIDTH/2, Constant.FIELD_LENGTH)

def inOpponentHalf():
    return Global.selfLoc.getY() > Constant.FIELD_WIDTH/2
    
