#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: Stucker.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#===============================================================================

"""
Stucker - Stuck Detection.
"""

import Kick
import Debug
##~ import Global
##~ import Constant
import HelpLong
##~ import HelpWhere
##~ import ReadyPlayer
    
def amIStuckBasedOnPWMDutyCycle():
    (maxPWM, _) = HelpLong.getStuckInfo()
       
    if Debug.stuckDebug:
        print "MaxPWM: %f" %maxPWM
    
    stuck = (maxPWM >= 1300 and Kick.framesSinceLastKicking >= 150)    
    return stuck

##~ def doStucker(stuckSolution = Constant.STUCK_SOLUTION_ONE_STANDSTILL):
##~     # Green = stucker.
##~     Global.myRole = Constant.STUCKER
##~     
##~     if stuckSolution == Constant.STUCK_SOLUTION_ONE_STANDSTILL:
##~         HelpLong.setNormalWalk(0, 0, 0)
##~         return
##~         
##~     elif stuckSolution == Constant.STUCK_SOLUTION_TWO_READYSTATE:
##~         if ReadyPlayer.kickOffPos == None:
##~             Debug.goAndMakeTraceBack()
##~             return
##~             
##~         if not HelpWhere.isNotAlongEdge():
##~             HelpLong.setNormalWalk(0, 0, 0)
##~             return
##~             
##~         if (Global.selfLoc.getPos()[0] >= ReadyPlayer.kickOffPos[0]):
##~             HelpLong.setNormalWalk(0, 15, 0)
##~             HelpLong.setHeadParams(80, 0, 0, Constant.HTAbs_h)
##~         else:
##~             HelpLong.setNormalWalk(0, -15, 0)
##~             HelpLong.setHeadParams(-80, 0, 0, Constant.HTAbs_h)

##~         if Global.lastForward > 0:
##~             if Debug.readyDebug:
##~                 print "Stuck - move backward! ------------------------- "
##~             HelpLong.setEllipticalWalk(-7, 0, 0)
##~             
##~         elif Global.lastForward < 0:
##~             if Debug.readyDebug:
##~                 print "Stuck - move forward! -------------------------- "
##~             HelpLong.setEllipticalWalk(4, 0, 0)
##~         
##~         else:
##~             if Debug.readyDebug:
##~                 print "Stuck - stand still. --------------------------- "
##~             HelpLong.setNormalWalk(0, 0, 0)
##~     
##~     else:
##~         print stuckSolution
##~         Debug.goAndMakeTraceBack()
##~     
##~ def DecideNextAction():
##~     Global.frameReset()
##~     HelpLong.setEllipticalWalk(Debug.debugForward, Debug.debugLeft, Debug.debugTurnCCW)
##~     amIStuck()
##~     HelpLong.superDebug()
