#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: TestingP.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#
# TestingP.py
#
# A very very basic player for you to start with. Can reference with KimPlayer.py.
#
#===============================================================================


"""
Testing player.
"""
import LocateBall
import Global
import HelpLong
import HelpTrack
import VisionLink
import OpenChallenger
import Constant
from StateBasedAction import StateBasedAction

def testBallVelocity():
    v = Global.Vector( *VisionLink.getGPSBallVInfo(1) )
    (x,y) = v.getPos()
    print "V Ball = %.2f %.2f %.2f" % (x,y,v.getDistance())
    

myTestingState = OpenChallenger.BlockingDog()

class DummyState( StateBasedAction ):
    def __init__(self):
        StateBasedAction.__init__(self)
        
    def DoAction(self):
        if self.counter > 10:
            return self.outState
        else: return self
        
myGrabBall = OpenChallenger.MyGrabBall()
dummyState = DummyState() 
headControl = OpenChallenger.MyActiveLocalise()
myGrabBall.setOutState(dummyState)
dummyState.setOutState(myGrabBall)
myState = dummyState

def testGrabBallWithChinSensor():
    global myState
    myState = myState.DecideNextAction()
    if myState == dummyState:
        print "Successful"
    elif myState is None:
        print "Failed"
        myState = dummyState
        
def testGrabBallCondition():
    OpenChallenger.resetEachFrame()
    headControl.DecideNextAction()
    if myGrabBall.shouldGrabTheBall():
        print " --- ",OpenChallenger.localBallX, OpenChallenger.Global.ballD
    if myGrabBall.shouldGrabTheBall() or myGrabBall.isDoing:
        myGrabBall.DecideNextAction()
        
bStop = False
bDoItOnce = False
def testOpenChallenger():
    global bStop
    OpenChallenger.resetEachFrame()
    headControl.DecideNextAction()
    if not (bDoItOnce and bStop):
        outState = myTestingState.DecideNextAction()
    else:
        outState = None
    if outState != myTestingState:
        bStop = True
        
##~     if myTestingState.DecideNextAction() is None:
##~         HelpLong.setNormalWalk(0,0,0)
        

irDistances = [0]*30
def testObstacleAvoidance():
    HelpTrack.spinningLocalise(lowCrane = -10, highCrane = -10, tilty = 0,speed = 3)
    irDistances.pop(0)
    irDistances.append(VisionLink.getAnySensor(Constant.ssINFRARED_NEAR))
    print min(irDistances)
    
def RandomKick():
    if Global.frame % 5 == 0:
        return Constant.UpennLeftWT
    elif Global.frame % 5 == 1:
        return Constant.UpennRightWT
    elif Global.frame % 5 == 2:
        return Constant.HandKickLeftWT
    elif Global.frame % 5 == 3:
        return Constant.HandKickRightWT
    elif Global.frame % 5 == 4:
        return Constant.DiveKickWT
    else:
        return False
        
class KickBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.kickCounter = 0
        self.seenBall = False
        
    def beginAction(self):
        self.kickCounter = 0
        self.seenBall = False
    
    def DoAction(self):
        Global.finalAction[Constant.AAWalktype] = RandomKick()
        HelpLong.setForceStepComplete()
        return self.outState

class TestKickBall(StateBasedAction):
    def __init__(self):
        StateBasedAction.__init__(self)
        self.rag = OpenChallenger.RunToGrabBall()
        self.kickBall = KickBall()
        self.rag.setOutState(self.kickBall)
        
    def DoAction(self):
        if self.subState is None:
            self.doSubState(self.rag)
        else:
            self.doSubState()
        return self
        

testKickBall = TestKickBall()
    
def testKickBallGrab():
    OpenChallenger.resetEachFrame()
    headControl.DecideNextAction()
    testKickBall.DecideNextAction()
    
def testWalking():
    HelpLong.setEllipticalWalk(0,0,0)
    
def testKick():
    Global.finalAction[Constant.AAWalktype] = Constant.FwdKickWT
    
def DecideNextAction():
    Global.frameReset()
    testKickBallGrab()
##~     LocateBall.headFindBall(-10, 0)
