#
#   Copyright 2004 The University of New South Wales (UNSW) and National  
#   ICT Australia (NICTA).
#
#   This file is part of the 2004 team rUNSWift RoboCup entry.  You may  
#   redistribute it and/or modify it under the terms of the GNU General  
#   Public License as published by the Free Software Foundation; either  
#   version 2 of the License, or (at your option) any later version as  
#   modified below.  As the original licensors, we add the following  
#   conditions to that license:
#
#   In paragraph 2.b), the phrase "distribute or publish" should be  
#   interpreted to include entry into a competition, and hence the source  
#   of any derived work entered into a competition must be made available  
#   to all parties involved in that competition under the terms of this  
#   license.
#
#   In addition, if the authors of a derived work publish any conference  
#   proceedings, journal articles or other academic papers describing that  
#   derived work, then appropriate academic citations to the original work  
#   must be included in that publication.
#
#   This rUNSWift source is distributed in the hope that it will be useful,  
#   but WITHOUT ANY WARRANTY; without even the implied warranty of  
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along  
#   with this source code; if not, write to the Free Software Foundation,  
#   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# 
#  Last modification background information
#  $Id: VisionLink.py 4365 2004-09-22 07:14:44Z kcph007 $
# 
#  Copyright (c) 2004 UNSW
#  All Rights Reserved.
# 




#===============================================================================
#   Python Behaviours : 2004 (c) 
#
# VisionLink.py
#
# Actual implementation of VisionLink is in PyEmbed.cc in robot7/vision.
# This file is here just because so that when we type "pychecker *.py", there 
# will not be any complain.
#
#===============================================================================

#===============================================================================
# Constants.
#===============================================================================

NUM_OF_EFFECTORS        = 1
NUM_SENSORS             = 1
NUM_TEAM_MEMBER         = 1
BALL_RADIUS             = 1.0
FIELD_WIDTH             = 1
FIELD_LENGTH            = 1
WALL_THICKNESS          = 1
GOAL_WIDTH              = 1
GOAL_LENGTH             = 1

#===============================================================================
# Functions belong to this module.
#===============================================================================

# Because each function must have something indented as its content, empty 
# function needs to have the keyword "pass".

# Functions listed here should always be the same as the ones in Vision_methods
# table in PyEmbed.cc. 

#---------------------------------------
# General functions
def setCallbacks(*arg):
    pass
    
#---------------------------------------
# Actuator related functions
def sendAtomicAction(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def sendIndicators(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)    
def sendMessageToBase(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def getBatteryLevel(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def getFallenState(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def getPressSensorCount(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def getJointSensor(*arg):
    pass 
#what is it? (please fill me in with comments, inputs + returning values..)
def getAnySensor(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getJointPWMDuty(*arg):
    pass
# Gets information regarding the current walk
# Returns a tuple of:
# (currentWalkType, currentStep, currentPG, leading_leg, frontShoulderHeight,
# bodyTilt, desiredPan, desiredTilt, desiredCrane, isHighGain)
# from actuator control
def getPWalkInfo(*arg):
    pass

#---------------------------------------
# Communcations functions
def sendEnvironmentTeamMates(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def sendCompressedCPlane(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def sendOPlane(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def sendEnvironmentBaseStation(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)    
def sendYUVPlane(*arg):
    pass

# From revision 3146: sendMyBehaviourInfo(ballDist, isStriker, isGoalie, haveBall, kickedOff
#                                      , isDefending, isBackingOff)
def sendMyBehaviourInfo(*arg):
    pass
    
#---------------------------------------
# GPS Functions
def setGPSGoal(*arg):
    pass
    
def setIfGPSMotionUpdate(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)    
def setIfGPSVisionUpdate(*arg):
    pass
# Pass true to keep gps opponent updating on, false to turn it off
def setIfGPSOpponentUpdate(*arg):
    pass
# Resets the edge pixel stationary map
def resetEdgeMap(*arg):
    pass
#For localisation challenge. Set to true if you want to record pink blobs.    
def setAllowPinkMapping(*arg):
    pass
# Sets the gps location to the position where a (hopefully) global maximum
# in field line match occurs. Takes no arguments, returns no arguments.
# You would usually run this after standing still and stationary localising,
# otherwise the line information won't be sufficient to get a good fix on
# your location.
def setGlobalMaxEdge(*arg):
    pass
#Returns true if gps used a pink blob to map / localise off (for localisation
#challenge)
def getUsePinkUpdate(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)    
def getIfGPSVisionUpdate(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def setGPSPaused(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSSelfInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSSelfCovariance(*arg):
    pass

def getGPSBallInfo(*arg):
    pass
# Gets GPS ball velocity, need to pass a Constant.CTGlobal or Constant.CTLocal argument.
# Returns a tuple of (vel x[cm/frame], vel y[cm/frame], speed[cm/frame],
# vel angle [degrees], vel angle - 90[degrees], normalized angle [doesn't work])
def getGPSBallVInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSBallMaxVar(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)    
def getGPSVBallMaxVar(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSOpponentInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSOpponentCovMax(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSTeammateInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getOppGoalInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getOwnGoalInfo(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getGPSCoordArray(*arg):
    pass
#what is it? (please fill me in with comments, inputs + returning values..)
def getSelfLocation(*arg):
    pass
#what is it?
def getBallLocation(*arg):
    pass
#what is it?
def getTeamColor(*arg):     # Returns 0 for blue team, 1 for red
    pass
#what is it?
def getGPSTeammateBallInfo(*arg):
    pass

#---------------------------------------
# Vision functions
def getVisualObject(*arg):
    pass

def getColouredPixelCount(*arg):    # Not implemented
    pass

def getBallDistance(*arg):
    pass 

def getBallHeading(*arg):
    pass 

def getBallConfidence(*arg):
    pass 

# Set to false to indicate visualcortex should NOT look for beacons and goals
def setUseBeacons(*arg):
    pass 

#---------------------------------------
# Wireless functions
def getSharedBallInfo(*arg):
    pass

#Get teammates behaviours values, like isAttacker, isDefender...
def getWirelessTeammateInfo(*arg):
    pass
    
#---------------------------------------
# GameController functions
def getTheCurrentMode(*arg):
    pass
    
def getKickOffState(*arg):
    pass

# Call this to skip stationary localising, and
# disable robot demobilisation using head button
# (useful for challenges)
def setMinimalMode(*arg):
    pass
#---------------------------------------
# Other functions
def doBasicBehaviour(*arg):
    pass 

#return Behaviour::PLAYER
def getMyPlayerNum(*arg):
    pass 

#what is it?
def getProjectedBall(*arg):
    pass
    
#what is it?
def printCPlusPlus(*arg):
    pass
    
#get dog's battery capacity range = [0..90+] ???
def getRemainingCapacity(*arg):
    pass

def getBatteryCurrent(*arg):
    pass
    
#get dog's temperature    
def getTemperature(*arg):
    pass
#what is it?
def getCPUUsage(*arg):
    pass
#what is it?
def getCurrentPreviousFrameID(*arg):
    pass
   
#---------------------------------------
# Wrapping functions that are using the old C++ codes.        

#what is it?
def getHeadingToBestGap(*arg):  
    pass

#return 2-tuple (seconds, useconds) equivalent to SystemTime in C++
def getCurrentTime(*arg):
    pass

#what is it? (please fill me in with comments, inputs + returning values..)
def getProjectedPoint(*arg):
    pass

#set team color, 0 = blue, 1 = red
def setGPSGoal(*arg):
    pass
    
#send parameter in learned walk.
#EllipticalWalk --> "ELI ..."
#SkellipticalWalk --> "SKE ..."
def setWalkLearningParameters(*arg):
    pass
    
def getRedBlobInfo(*arg):
    pass
    
def PointToHeading(*arg):
    pass
    
def PointToElevation(*arg):
    pass 

def getTestingInfo(*arg):
    pass
    
