/*

   Copyright 2003 The University of New South Wales (UNSW) and National  
   ICT Australia (NICTA).

   This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
   redistribute it and/or modify it under the terms of the GNU General  
   Public License as published by the Free Software Foundation; either  
   version 2 of the License, or (at your option) any later version as  
   modified below.  As the original licensors, we add the following  
   conditions to that license:

   In paragraph 2.b), the phrase "distribute or publish" should be  
   interpreted to include entry into a competition, and hence the source  
   of any derived work entered into a competition must be made available  
   to all parties involved in that competition under the terms of this  
   license.

   In addition, if the authors of a derived work publish any conference  
   proceedings, journal articles or other academic papers describing that  
   derived work, then appropriate academic citations to the original work  
   must be included in that publication.

   This rUNSWift source is distributed in the hope that it will be useful,  
   but WITHOUT ANY WARRANTY; without even the implied warranty of  
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
   General Public License for more details.

   You should have received a copy of the GNU General Public License along  
   with this source code; if not, write to the Free Software Foundation,  
   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * @author Will Uther
 *
 * Last modification background information
 * $Id: FieldDef.h 
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
 **/



#ifndef FieldDef_h_DEFINED
#define FieldDef_h_DEFINED

static const int LEFT = 1;
static const int RIGHT = 2;

/* There used to be constants for a smaller field. Removed since rev 2567. */

// actual dimension of the field
static const int FIELD_WIDTH = 290;
static const int FIELD_LENGTH = 440;
static const int FIELD_DIAGONAL = 527;
static const int WALL_THICKNESS = 10;
static const int GOAL_WIDTH = 60;
static const int GOAL_LENGTH = 30;
static const int CORNER_WIDTH = 50; // this is the width of the corner triangle 
// + 2*wall thickness
static const int GOALBOX_WIDTH = 100;
static const int GOALBOX_DEPTH = 50;
static const int CIRCLE_DIAMETER = 30;

#endif // FieldDef_h_DEFINED
