/*

   Copyright 2003 The University of New South Wales (UNSW) and National  
   ICT Australia (NICTA).

   This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
   redistribute it and/or modify it under the terms of the GNU General  
   Public License as published by the Free Software Foundation; either  
   version 2 of the License, or (at your option) any later version as  
   modified below.  As the original licensors, we add the following  
   conditions to that license:

   In paragraph 2.b), the phrase "distribute or publish" should be  
   interpreted to include entry into a competition, and hence the source  
   of any derived work entered into a competition must be made available  
   to all parties involved in that competition under the terms of this  
   license.

   In addition, if the authors of a derived work publish any conference  
   proceedings, journal articles or other academic papers describing that  
   derived work, then appropriate academic citations to the original work  
   must be included in that publication.

   This rUNSWift source is distributed in the hope that it will be useful,  
   but WITHOUT ANY WARRANTY; without even the implied warranty of  
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
   General Public License for more details.

   You should have received a copy of the GNU General Public License along  
   with this source code; if not, write to the Free Software Foundation,  
   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Last modification background information
 * $Id: VisualCortex.h 916 2003-04-08 00:58:24Z willu $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 *
 * Object identification from blobs
 * ---------------------------------
 * This VisualCortex-prev.h is a very old .h file served like VisualCortex.h
 * before. Somewhat outdated but still keep, because some are still used.
 * 
 **/

#ifndef VisualCortex_priv_h_DEFINED
#define VisualCortex_priv_h_DEFINED

#include "VisualCortex.h"

const int trainingExpCount = 9;

/* Training examples for orientations */
const double trainingData[trainingExpCount][30] = {
	{ - 90,
		3,
		0.478261,
		-0.830508,
		0.057584,
		0.891304,
		-0.525424,
		0.031601,
		-0.271739,
		0.169492,
		0.910815},
		{ - 90,
			4,
			0.826667,
			-0.830508,
			0.058095,
			-0.666667,
			-0.559322,
			0.034082,
			-0.173333,
			0.271186,
			0.870643,
			0.253333,
			-0.101695,
			0.037180},
			{180,
				6,
				0.577465,
				-0.660000,
				0.152574,
				-0.408451,
				-0.340000,
				0.136949,
				-0.859155,
				-0.240000,
				0.116728,
				0.267606,
				0.440000,
				0.358456,
				-0.676056,
				0.560000,
				0.204963,
				0.732394,
				0.560000,
				0.030331},
				{180, 6, -0.451613, -0.666667, 0.177846, 0.822581, -0.229167, 0.090447,
					0.451613, -0.125000, 0.044715, -0.193548, 0.479167, 0.481707, -0.903226,
					0.583333, 0.061992, 0.790323, 0.666667, 0.143293},
					{0,
						3,
						-0.348485,
						-0.200000,
						0.695160,
						0.696970,
						0.457143,
						0.255407,
						-0.924242,
						0.371429,
						0.049434},
						{0,
							4,
							0.632353,
							-0.836735,
							0.031306,
							-0.235294,
							-0.102041,
							0.601968,
							-0.941176,
							0.265306,
							0.054562,
							0.647059,
							0.510204,
							0.312165},
							{0, 3, 0.050000, -0.147059, 0.784648, -0.866667, 0.529412, 0.123667,
								0.883333, 0.529412, 0.091684},
								{90, 4, -0.826667, -0.830508, 0.058095, 0.666667, -0.559322, 0.034082,
									0.173333, 0.271186, 0.870643, -0.253333, -0.101695, 0.037180},
									{90, 3, -0.896226, -0.766667, 0.046496, 0.235849, 0.066667, 0.755075,
										0.792453, 0.000000, 0.198428}
};

// number of VisualObject fields after the certainty factor
static const int numVOFields = 12;

static const int kBallMinSize = 15; // readjusted for hires
static const int kFieldGreenThreshold = 30; // used by NoGreenNearBy()

static const int kHalfBeaconMinSize = 5;  // Modified to 5 for the new field
static const double kGoalDimensionRatio = 2.23; // Ratio of Width / Height
// is how we got these values for a minimum

static const double beaconSizeTol = 0.25; // this is the tolerance of the two masses of the halfbeacons it tries to match

static const int kMinBlueRobotSize = 30;
static const int kMinRedRobotSize = 30; // used in FindRobot()

#ifdef EDGE_DETECT

#undef HOUGH_USE_HOUGH //Disable HOUGH_USE_HOUGH to use new type of edge matching
//{{{

//Magic numbers taken out of edge detect
static const int ELEMENTS_PER_EDGELIST_ENTRY = 3;


//NightOwl
//

static const int GRADFIELD_DIAGONAL = 1;

static const int maxNumTests = 3;

//NOTE: all the arrays below must have at least maxNumTests elements in them.
//Note: every element in the 3 arrays below MUST BE ODD.
static const int numSamplesX[maxNumTests] = {
	5, 3, 3
};    //NOTE: CHANGE maxNumSamplesX, maxNumSamplesY and maxNumSamplesT in VisualCortex.h if you change these!!!!
static const int numSamplesY[maxNumTests] = {
	5, 3, 3
};
static const int numSamplesT[maxNumTests] = {
	5, 3, 3
};
static const int distSamplesX[maxNumTests] = {
	15, 5, 2
};
static const int distSamplesY[maxNumTests] = {
	15, 5, 2
};
static const int distSamplesT[maxNumTests] = {
	5, 5, 2
};
static const int abortBorder[maxNumTests] = {
	0, 0, 0
};  //For each test where the element in this array is '1', 
//if we've searched and landed on one of the outer 
#ifndef OFFLINE                                                         //elements then abort. 
static SystemTime timeStart;
#endif
static const int abortTime = 30000;  //number of microseconds after the frame comes in before we abort 
//edge detection (in the interests of keeping the framerate up). 
//Remember that we only have 40ms to do everything in each frame, 
//GPS takes up to 1.5ms and Behaviours can take up to 7ms. 


//Misc vars
static const int maxEdgeThin = 20; //if not equal to zero then once the number of edges 
//reaches this number, the edge array gets evenly resampled
//with this number of samples (ie. samples get taken every 
//numEdges/maxEdgeThin edges). This is independant of 
//MAX_EDGES which sets the upper bound after which we stop
//looking for edges.

//The following consists of pairs where the first number is the decimal 
//representation of the binary bit pattern of a given line type. The second number 
//is the line type that this represents. 
static const uchar edgeTypeTableInit[] = {
	31,
	0,
	159,
	1,
	15,
	1,
	143,
	2,
	135,
	3,
	207,
	3,
	199,
	4,
	231,
	5,
	195,
	5,
	227,
	6,
	225,
	7,
	243,
	7,
	241,
	0,
	249,
	1,
	240,
	1,
	248,
	2,
	120,
	3,
	252,
	3,
	124,
	4,
	126,
	5,
	60,
	5,
	62,
	6,
	30,
	7,
	63,
	7
};
//The following consists of pairs where the 2*n'th element 
//is the starting angle and 2*n+1'th element the finishing angle 
//of any line of type n where n is given by the table above. 
static const uchar edgeAngleTable[] = {
	157, 203, 135, 180, 112, 158, 90, 135, 67, 113, 45, 90, 22, 68, 0, 45
};  //45 degree set
//The following consists of point pairs being the locations of the field lines 
//on the field relative to the origin (NOT the field edges, that's in another table). 
//All references are assuming observer is at the home goal looking up the field, 
//NOTE: every 'line' on the field is in fact 2 lines separated by 2cm (the width 
//of the tape used to mark the field). 
static const int fieldLinesTable[] = {
	115, 8, 175, 8,    //0  Home goal line near line
	115, 10, 175, 10,   //1  Home goal line far line
	94, 10, 94, 60,   //2  Left edge of home goal box, left line
	96, 10, 96, 60,   //3  Left edge of home goal box, right line
	194, 10, 194, 60,   //4  Right edge of home goal box, left line
	196, 10, 196, 60,   //5  Right edge of home goal box, right line
	94, 59, 196, 59,   //6  Top edge of home goal box, near line
	94, 61, 196, 61,   //7  Top edge of home goal box, far line
	10, 219, 280, 219,  //8  Midline, near line
	10, 221, 280, 221,  //9  Midline, far line
	94, 379, 196, 379,  //10 Top edge of target goal box, near line
	94, 381, 196, 381,  //11 Top edge of target goal box, far line
	94, 379, 94, 430,  //12 Left edge of target goal box, left line
	96, 379, 96, 430,  //13 Left edge of target goal box, right line
	194, 379, 194, 430,  //14 Right edge of target goal box, left line
	196, 379, 196, 430,  //15 Right edge of target goal box, right line
	115, 430, 175, 430,  //16 Target goal line near line
	115, 432, 175, 432   //17 Target goal line far line

};
//static const int numFieldLines = 9; //1 for each line (ie. half the number of rows in the 
//table above) 
//MOVED INTO VisualCortex.h
static const int horizLines[] = {
	0, 3, 4, 5, 8
};
static const int numHorizLines = 5;
static const int vertLines[] = {
	1, 2, 6, 7
};
static const int numVertLines = 4;
//The following consists of point pairs being the locations of the field edges 
//on the field relative to the origin (NOT the field lines, that's in another table).
static const int fieldEdgesTable[] = {
	10, 40, 10, 400,  //18 Left edge of field
	280, 40, 280, 400,  //19 Right edge of field
	40, 10, 250, 10,   //20 Baseline
	40, 430, 250, 430,  //21 Target line
	40, 10, 10, 40,   //22 Bottom left cutoff
	250, 10, 280, 40,   //23 Bottom right cutoff
	10, 400, 40, 430,  //24 Top left cutoff
	280, 400, 250, 430   //25 Top right cutoff

};
//static const int numEdgeLines = 8;  //moved into VisualCortex.h
//
static const int horizEdges[] = {
	2, 3
};
static const int numHorizEdges = 2;
static const int vertEdges[] = {
	0, 1
};
static const int numVertEdges = 2;
static const int diagEdges[] = {
	4, 5, 6, 7
};
static const int numDiagEdges = 4;
typedef enum lineDirectionType_e {
	LINE_HORIZONTAL = 0,
	LINE_VERTICAL = 1
} lineDirectionType;
static const lineDirectionType lineDirectionTable[] = {
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_VERTICAL,
	LINE_HORIZONTAL,
	LINE_HORIZONTAL
};
typedef enum edgeDirectionType_e {
	EDGE_VERTICAL = 0,
	EDGE_HORIZONTAL = 1,
	EDGE_DIAGONAL = 2
} edgeDirectionType;
static const edgeDirectionType edgeDirectionTable[] = {
	EDGE_VERTICAL,
	EDGE_VERTICAL,
	EDGE_HORIZONTAL,
	EDGE_HORIZONTAL,
	EDGE_DIAGONAL,
	EDGE_DIAGONAL,
	EDGE_DIAGONAL,
	EDGE_DIAGONAL
};
//}}}

#endif //EDGE_DETECT



#endif // VisualCortex_priv_h_DEFINED
